package de.bsvrz.buv.plugin.ereigniskal;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * Definitionsdialog fr verkehrliche Gueltigkeiten. Die Klasse liefert ein Eingabefelder, in denen die rauemliche
 * Gltigkeit bestimmt werden kann. <br>
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-11</li>
 * </ul>
 * 
 * @version $Revision: 1.4 $ / $Date: 2010/02/04 05:57:26 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class DefinitionVerkehrlicheGueltigkeit extends Dialog
{

  private Shell shell = null; // @jve:decl-index=0:visual-constraint="204,120"

  private Composite compositeTop = null;

  private Composite compositeBottom = null;

  private Button buttonOk = null;

  private Button buttonAbbrechen = null;

  private Label label = null;

  private Combo combo = null;

  private Text text = null;

  private Label label1 = null;

  private Text text1 = null;

  private Combo combo1 = null;

  private String _vonText = null;

  private String _vonCombo = null;

  private String _bisText = null;

  private String _bisCombo = null;

  /**
   * Speichert die in diesem Dialog erfassten Daten.
   */
  private EintragVerkehrlicheGueltigkeit _datensatzVerkehrlicheGueltigkeit = null;

  /**
   * Konstruktor, liefert eine neue Instanz der Klasse {@link DefinitionVerkehrlicheGueltigkeit}.
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public DefinitionVerkehrlicheGueltigkeit(Shell parent)
  {
    super(parent);
  }

  /**
   * ffnet den Dialog {@link DefinitionVerkehrlicheGueltigkeit} zur Definition fr verkehrliche Gueltigkeiten
   * 
   * @return Datensatz der verkehrlichen Gueltigkeit.
   */
  public EintragVerkehrlicheGueltigkeit oeffne()
  {
    // shell = new Shell();
    shell = new Shell(getParent(), SWT.TITLE | SWT.APPLICATION_MODAL | SWT.CLOSE);
    shell.setText("Definition verkehrliche Gltigkeit");

    shell.setLayout(new GridLayout());
    createCompositeTop();
    createCompositeBottom();
    shell.setSize(new Point(234, 148));
    shell.open();

    Display display = getParent().getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _datensatzVerkehrlicheGueltigkeit;
  }

  /**
   * Generiert die Elemente des Dialogs {@link DefinitionVerkehrlicheGueltigkeit}.
   * 
   */
  private void generiereGui()
  {
  }

  /**
   * bernimmt die nderungen der verkehrlichen Gueltigkeit und schliet den Dialog.
   * 
   */
  private void aktionOk()
  {

    _vonText = text.getText();
    _vonCombo = combo.getText();
    _bisText = text1.getText();
    _bisCombo = combo1.getText();

    SimpleDateFormat sdf = new SimpleDateFormat("HH:mm");
    try
    {
      Date parse = sdf.parse(_vonText);
      parse = sdf.parse(_bisText);

      Calendar cal = new GregorianCalendar().getInstance();

      Long start = new Date().getTime();
      String[] split = _vonText.split(":");
      cal.add(Calendar.HOUR, new Integer(split[0]));
      cal.add(Calendar.MINUTE, new Integer(split[1]));
      Long ende = cal.getTimeInMillis();

      Long von = ende - start;
      cal = new GregorianCalendar().getInstance();

      String[] split2 = _bisText.split(":");
      cal.add(Calendar.HOUR, new Integer(split2[0]));
      cal.add(Calendar.MINUTE, new Integer(split2[1]));
      ende = cal.getTimeInMillis();

      Long bis = ende - start;

      EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt bezugVon = null;
      EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt bezugBis = null;

      if (_vonCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorAnfang.toString()))
        bezugVon = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorAnfang;
      else if (_vonCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachAnfang.toString()))
        bezugVon = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachAnfang;
      else if (_vonCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorEnde.toString()))
        bezugVon = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorEnde;
      else if (_vonCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachEnde.toString()))
        bezugVon = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachEnde;

      if (_bisCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorAnfang.toString()))
        bezugBis = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorAnfang;
      else if (_bisCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachAnfang.toString()))
        bezugBis = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachAnfang;
      else if (_bisCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorEnde.toString()))
        bezugBis = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.vorEnde;
      else if (_bisCombo.equals(EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachEnde.toString()))
        bezugBis = EintragVerkehrlicheGueltigkeit._Bezugszeitpunkt.nachEnde;

      _datensatzVerkehrlicheGueltigkeit = new EintragVerkehrlicheGueltigkeit(von, bezugVon, bis, bezugBis);

      shell.dispose();
    }
    catch (ParseException e)
    {
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
      mb.setText("Fehler Eingabe");
      mb.setMessage("Datumseingabe muss in der Form: HH:mm erfolgen!");
      mb.open();
      return;
    }

  }

  /**
   * Verwirft die nderungen an der verkehrlichen Gueltigkeit und schliet den Dialog.
   * 
   */
  private void aktionAbbrechen()
  {
    _datensatzVerkehrlicheGueltigkeit = null;
    shell.dispose();
  }

  /**
   * This method initializes compositeTop
   * 
   */
  private void createCompositeTop()
  {
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 3;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.CENTER;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    compositeTop = new Composite(shell, SWT.NONE);
    compositeTop.setLayoutData(gridData);
    compositeTop.setLayout(gridLayout);
    label = new Label(compositeTop, SWT.NONE);
    label.setText("Von:");
    text = new Text(compositeTop, SWT.BORDER);
    text.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _vonText = text.getText();

      }
    });
    createCombo();
    label1 = new Label(compositeTop, SWT.NONE);
    label1.setText("Bis:");
    text1 = new Text(compositeTop, SWT.BORDER);
    text1.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _bisText = text1.getText();

      }
    });
    createCombo1();
  }

  /**
   * This method initializes compositeBottom
   * 
   */
  private void createCompositeBottom()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.justify = false;
    rowLayout.wrap = true;
    rowLayout.pack = false;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.CENTER;
    gridData1.grabExcessHorizontalSpace = false;
    gridData1.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(shell, SWT.NONE);
    compositeBottom.setLayoutData(gridData1);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");   
    buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOk();
			}			
		});
    
    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionAbbrechen();
			}			
		});
  }

  /**
   * This method initializes combo
   * 
   */
  private void createCombo()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.CENTER;
    gridData2.grabExcessHorizontalSpace = false;
    gridData2.verticalAlignment = GridData.CENTER;
    combo = new Combo(compositeTop, SWT.READ_ONLY);
    combo.setLayoutData(gridData2);
    combo.add("vorAnfang");
    combo.add("nachAnfang");
    combo.add("vorEnde");
    combo.add("nachEnde");
    combo.setText("vorAnfang");
    combo.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _vonCombo = combo.getText();

      }
    });

  }

  /**
   * This method initializes combo1
   * 
   */
  private void createCombo1()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.CENTER;
    gridData2.grabExcessHorizontalSpace = false;
    gridData2.verticalAlignment = GridData.CENTER;
    combo1 = new Combo(compositeTop, SWT.READ_ONLY);
    combo1.setLayoutData(gridData2);
    combo1.add("vorAnfang");
    combo1.add("nachAnfang");
    combo1.add("vorEnde");
    combo1.add("nachEnde");
    combo1.setText("vorEnde");
    combo1.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _bisCombo = combo1.getText();
      }
    });

  }

}
