package de.bsvrz.buv.plugin.ereigniskal;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.Formatter;
import java.util.GregorianCalendar;
import java.util.List;

import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.ereigniskal.VerwaltungsSicht.BaseComapator;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit.Eingabetyp;
import de.bsvrz.buv.rw.basislib.login.UrlasserDialog;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.Data.ReferenceArray;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.AttributeGroupUsage;
import de.bsvrz.dav.daf.main.config.ConfigurationArea;
import de.bsvrz.dav.daf.main.config.ConfigurationAuthority;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.ObjectSet;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectInfo;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * ber den Definitionsdialog muss ein EreigniskalenderEintrag neu angelegt bzw. ein existierender Eintrag gendert
 * werden knnen.
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-10</li>
 * <li>TAnf-Vi-BW-C3-11</li>
 * </ul>
 * 
 * @version $Revision: 1.4 $ / $Date: 2010/02/04 05:57:26 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class EreignisKalenderDefinitionsdialog extends Dialog
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * TableViewer
   */
  private static TableViewer _tvVerkehrlich = null;

  /**
   * TableViewer
   */
  private static TableViewer _tvRaeumlich = null;

  /**
   * TableViewer
   */
  private List<EintragVerkehrlicheGueltigkeit> _lEintragVerkehrlicheGueltigkeit = null;

  /**
   * TableViewer
   */
  private List<EintragRaeumlicheGueltigkeit> _lEintragRaeumlicheGueltigkeit = null;

  /**
   * FilterSpeicher.
   */
  private EintragVerkehrlicheGueltigkeit _eintragVerkehrlicheGueltigkeit; // @jve:decl-index=0:

  /**
   * FilterSpeicher.
   */
  private EintragRaeumlicheGueltigkeit _eintragRaeumlicheGueltigkeit; // @jve:decl-index=0:

  /**
   * FilterSpeicher.
   */
  private Eintrag _eintrag = null;

  // private EditorRegulaererAusdruck _editorRegulaererAusdruck = null;
  private Shell shell = null; // @jve:decl-index=0:visual-constraint="96,108"

  private Composite composite = null;

  private Label labelName = null;

  private Text textName = null;

  private Label labelQuelle = null;

  private Text textQuelle = null;

  private Group groupFilterDefinitionen = null;

  private Composite compositeBottom = null;

  private Button buttonOk = null;

  private Button buttonAbbrechen = null;

  private Button buttonHilfe = null;

  private Button buttonNeu1 = null;

  private Button buttonBearbeiten1 = null;

  private Button radioButton3 = null;

  private Label label3 = null;

  private Group groupZeitspezifikation = null;

  private Composite compositeZeitBereich = null;

  private Label label4 = null;
  private Label label5 = null;

  private DatumZeit zeitVon = null;
  private DatumZeit zeitBis = null;

  // private Text textAnfangDatum = null;

 // private Text textAnfangZeit = null;
  
 // private Text textEndDatum = null;

 // private Text textEndZeit = null;

  private Composite compositeDatum = null;

  private Label labelDatum = null;

  private Text textDatum = null;

  private Label labelAnfangJahr = null;

  private Text text = null;

  private Label labelEndJahr = null;

  private Text text1 = null;

  private Composite compositeFreieDef = null;

  private Label labelFreieDef = null;

  private Text textFreieDef = null;

  private DaVKommunikation _daVKommunikation = DaVKommunikation.getInstanz();

  private Label labelBeschreibung = null;

  private Text textArea = null;

  private Label labelTyp = null;

  private Combo combo = null;

  private ComboViewer comboViewer = null;

  private Combo combo2 = null;

  private ComboViewer comboViewer2 = null;

  private Composite compositeSyskal = null;

  private Label label = null;

  private Composite composite1 = null;

  private Composite compositeFilterDef = null;

  private Button radioButton1 = null;

  private Label label1 = null;

  private Button radioButton2 = null;

  private Label label2 = null;

  private Group groupVerkehrlich = null;

  private Composite composite2 = null;

  private Composite compositeTabelleVk = null;

  private Composite compositeRechts = null;

  private Group groupRaeumlich = null;

  private Composite composite21 = null;

  private Composite compositeTabelleVk1 = null;

  private Composite compositeRechts1 = null;

  private Boolean _bearbeiten = null;

  private Boolean _kopieren = null;

  private Button buttonNeu11 = null;

  private Button buttonBearbeiten11 = null;

  private String _pid = null;

  private String _name = null;

  private String _beschreibung = null;

  private SystemObject _ereignisTyp = null;

  private String _quelle = null;

  private SystemObject _systemKalenderEintrag = null;

  private Long _zeitBereichAnfang = null;

  private Long _zeitBereichEnde = null;

  /**
   * Konstruktor fr eine neue Instanz der Klasse {@link EreignisKalenderDefinitionsdialog}
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public EreignisKalenderDefinitionsdialog(Shell parent)
  {
    super(parent);
    _lEintragVerkehrlicheGueltigkeit = new ArrayList<EintragVerkehrlicheGueltigkeit>();
    _lEintragRaeumlicheGueltigkeit = new ArrayList<EintragRaeumlicheGueltigkeit>();
    _eintrag = new Eintrag();

  }

  /**
   * ffnet den Dialog {@link EreignisKalenderDefinitionsdialog} zum Anlegen eines Eintrags.
   * 
   * @return Liefert den erzeugten Filter als Instanz der Klasse {@link Filter}.
   */
  public Eintrag oeffne()
  {
    _bearbeiten = false;

    Shell parent = getParent();
//    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    shell = new Shell();
    shell.setText("Definition Ereigniskalender");
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createGroupZeitspezifikation();
    createGroupVerkehrlich();
    createGroupRaeumlich();
    createCompositeBottom();

    _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe);

    shell.setSize(new Point(495, 679));

    shell.open();

    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _eintrag;
  }

  /**
   * ffnet den Dialog {@link EreignisKalenderDefinitionsdialog} zum Bearbeiten eines bereits erzeugten
   * Ereigniskalendereintrags.
   * 
   * @param betriebsMvDefinitionsdialogFilter
   *          Filter von Betriebsmeldungen, der bearbeitet werden soll.
   * @return Liefert <code>true</code>, falls der Filter bearbeitet wurde, sonst <code>false</code>. Wenn
   *         <code>true</code> geliefert wird, kann der Verwaltungsdialog Filter Betriebsmeldungen ({@link ZustandVerwaltungsdialog})
   *         die Darstellung der Liste der Filter aktualisieren.
   */
  public Eintrag oeffne(Eintrag eintrag, boolean kopieren)
  {
    _kopieren = kopieren;

    _bearbeiten = true;

    _eintrag = eintrag;

    _lEintragVerkehrlicheGueltigkeit = _eintrag.getListeEintragVerkehrlicheGueltigkeit();
    _lEintragRaeumlicheGueltigkeit = _eintrag.getListeEintragRaeumlicheGueltigkeit();

    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Ereigniskalender");
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createGroupZeitspezifikation();
    createGroupVerkehrlich();
    createGroupRaeumlich();
    createCompositeBottom();
    shell.setSize(new Point(495, 679));
    textName.setText(_eintrag.getName());
    textArea.setText(_eintrag.getBeschreibung());

    ISelection selection = null;
    if (_eintrag.getEreignisTyp() != null)
      selection = new StructuredSelection(_eintrag.getEreignisTyp());
    else
    {
      selection = new StructuredSelection(new DummySystemObject());
    }
    comboViewer2.setSelection(selection);
    textQuelle.setText(_eintrag.getQuelle());

    if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe))
    {
      radioButton1.setSelection(true);
      radioButton2.setSelection(false);
      // combo.setEnabled(false);

    }
    else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Systemkalendereintrag))
    {
      radioButton1.setSelection(false);
      radioButton2.setSelection(true);
//      textAnfangDatum.setEnabled(false);
//      textAnfangZeit.setEnabled(false);
//      textEndDatum.setEnabled(false);
//      textEndZeit.setEnabled(false);
      zeitVon.setEnabled(false);
      zeitBis.setEnabled(false);
      
      combo.setEnabled(true);

    }

    Date d1 = new Date();
    Date d2 = new Date();
    d1.setTime(_eintrag.getAnfangsZeitpunkt());
    d2.setTime(_eintrag.getEndZeitpunkt());
    zeitVon.setDatum(d1);
    zeitBis.setDatum(d2);
    
//    SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm");
//    date.setTime(_eintrag.getAnfangsZeitpunkt());
//    String strAnfang = sdf.format(date);
//
//    String[] split = strAnfang.split(" ");
//
//    textAnfangDatum.setText(split[0]);
//    textAnfangZeit.setText(split[1]);
//
//    date.setTime(_eintrag.getEndZeitpunkt());
//    String strEnde = sdf.format(date);
//
//    String[] split2 = strEnde.split(" ");
//
//    textEndDatum.setText(split2[0]);
//    textEndZeit.setText(split2[1]);
    

    ISelection selection2 = null;
    if (_eintrag.getSystemKalenderEintrag() != null)
      selection2 = new StructuredSelection(_eintrag.getSystemKalenderEintrag());
    else
    {
      selection2 = new StructuredSelection(new DummySystemObject());
    }

    comboViewer.setSelection(selection2);

    _tvRaeumlich.setInput(_eintrag.getListeEintragRaeumlicheGueltigkeit());
    _tvVerkehrlich.setInput(_eintrag.getListeEintragVerkehrlicheGueltigkeit());

    shell.open();

    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _eintrag;
  }

  /**
   * bernimmt die aktuellen Einstellungen. Dabei wird geprft,
   * <ul>
   * <li>ob eine Filterdefinition eingegeben wurde</li>
   * <li>dass ein Name eingegeben wurde</li>
   * </ul>
   * 
   */
  private void aktionOk()
  {
    Eintrag eintrag = new Eintrag();

    if (_name != null && _name.length() > 0)
    {
      if (!_bearbeiten || _kopieren)
        eintrag.setPid("ereignis." + _name.replaceAll(" ", ""));
      else
        eintrag.setPid(_eintrag.getPid());
      eintrag.setName(_name);
    }else{
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK | SWT.CANCEL);
      mb.setText("Fehler Definition");
      mb.setMessage("Es muss ein Name angegeben werden!");
      mb.open();
      return;
    }

    if (_beschreibung == null)
      _beschreibung = "";

    eintrag.setBeschreibung(_beschreibung);

    if (_ereignisTyp != null)
      eintrag.setEreignisTyp(_ereignisTyp);
    else{
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK | SWT.CANCEL);
      mb.setText("Fehler Definition");
      mb.setMessage("Es muss ein EreignisTyp angegeben werden!");
      mb.open();
      return;
    }

    if (_quelle == null)
      _quelle = "";

    eintrag.setQuelle(_quelle);

    if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe))
    {

      eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe);

//      SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm");
//
//      String anfangString = textAnfangDatum.getText() + " " + textAnfangZeit.getText();
//      String endeString = textEndDatum.getText() + " " + textEndZeit.getText();
//
//      try
//      {
//        _zeitBereichAnfang = sdf.parse(anfangString).getTime();
//        _zeitBereichEnde = sdf.parse(endeString).getTime();
//      }
//      catch (ParseException e)
//      {
//
//        _debug.fine(e.getMessage());
//
//      }
      _zeitBereichAnfang = zeitVon.getDatum().getTime();
      _zeitBereichEnde = zeitBis.getDatum().getTime();
      
      if (_zeitBereichEnde -_zeitBereichAnfang > 0){
        
      }
      else
      {
        MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK | SWT.CANCEL);
        mb.setText("Fehler Definition");
        mb.setMessage("Zeitbereichsangabe ungueltig!");
        mb.open();
        return;
      }
      

    }
    else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Systemkalendereintrag))
    {
      eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Systemkalendereintrag);
      _zeitBereichAnfang = new Date().getTime();
      _zeitBereichEnde = _zeitBereichAnfang;
      eintrag.setSystemKalenderEintrag(_systemKalenderEintrag);
    }

    eintrag.setAnfangsZeitpunkt(_zeitBereichAnfang);
    eintrag.setEndZeitpunkt(_zeitBereichEnde);

    eintrag.setListeEintragVerkehrlicheGueltigkeit(_lEintragVerkehrlicheGueltigkeit);
    eintrag.setListeEintragRaeumlicheGueltigkeit(_lEintragRaeumlicheGueltigkeit);

    _eintrag = eintrag;

    boolean eingabenGueltig = false;

    if (_name != null && _zeitBereichEnde != null && _zeitBereichAnfang != null && _ereignisTyp != null)
    {

      if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe))
      {
        if (_name.length() > 0 && _zeitBereichEnde > _zeitBereichAnfang)
          eingabenGueltig = true;

      }
      else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Systemkalendereintrag))
      {
        if (_name.length() > 0 && _systemKalenderEintrag != null)
          eingabenGueltig = true;
        else
        {
          MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK | SWT.CANCEL);
          mb.setText("Fehler Definition");
          mb.setMessage("SystemkalenderEintrag ungueltig!");
          mb.open();
          return;
        }

      }

    }

    if (eingabenGueltig)
    {
      
      if (!_bearbeiten || _kopieren){
        
        if (!_daVKommunikation.isObjektVorhanden(_eintrag.getPid()))
          _daVKommunikation.erzeugeEreignisKalenderEintrag(_eintrag);
        else{
          
          MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
          mb.setText("Fehler Definition");
          mb.setMessage("Eintrag schon vorhanden: " + _eintrag.getPid());
          mb.open();
          return;
                
        }
      }

      DataModel dataModel = _daVKommunikation.holeDaVVerbindung().getDataModel();

      AttributeGroup atg = dataModel.getAttributeGroup("atg.ereignisParameter");
      Aspect asp = dataModel.getAspect("asp.parameterVorgabe");
      Data data = _daVKommunikation.holeDaVVerbindung().createData(atg);

      data.getItem("BeginnZeitlicheGltigkeit").asTimeValue().setMillis(_zeitBereichAnfang);
      data.getItem("EndeZeitlicheGltigkeit").asTimeValue().setMillis(_zeitBereichEnde);
      if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Systemkalendereintrag))
        data.getItem("SystemKalenderEintragReferenz").asReferenceValue().setSystemObject(_systemKalenderEintrag);
      else
        data.getItem("SystemKalenderEintragReferenz").asReferenceValue().setSystemObject(null);

      ReferenceArray array1 = data.getItem("RumlicheGltigkeit").asReferenceArray();
      array1.setLength(_lEintragRaeumlicheGueltigkeit.size());
      for (int i = 0; i < _lEintragRaeumlicheGueltigkeit.size(); i++)
      {
        EintragRaeumlicheGueltigkeit e = _lEintragRaeumlicheGueltigkeit.get(i);
        array1.getReferenceValue(i).setSystemObject(e.getSystemObjekt());

      }

      Array array2 = data.getItem("VerkehrlicheGltigkeit").asArray();
      array2.setLength(_lEintragVerkehrlicheGueltigkeit.size());
      for (int i = 0; i < _lEintragVerkehrlicheGueltigkeit.size(); i++)
      {
        EintragVerkehrlicheGueltigkeit e = _lEintragVerkehrlicheGueltigkeit.get(i);
        array2.getItem(i).getItem("ZeitDauerAnfangIntervall").asTimeValue().setMillis(e.getVon());
        array2.getItem(i).getItem("ZeitBezugAnfangIntervall").asTextValue().setText(
            e.getVonBezugszeitpunkt().toString());
        array2.getItem(i).getItem("ZeitDauerEndeIntervall").asTimeValue().setMillis(e.getBis());
        array2.getItem(i).getItem("ZeitBezugEndeIntervall").asTextValue().setText(e.getBisBezugszeitpunkt().toString());
      }

      data.getItem("Quelle").asTextValue().setText(_quelle);

      UrlasserDialog urlasserDialog = new UrlasserDialog(shell);

      ResultData resultData = new ResultData(dataModel.getObject(eintrag.getPid()), new DataDescription(atg, asp),
          new Date().getTime(), data);
      List<ResultData> list = new ArrayList<ResultData>();
      list.add(resultData);

      if (!(urlasserDialog.anzeigen(list)).getEingabeOk() && !_bearbeiten)
        _daVKommunikation.loescheEreignisKalenderEintrag(eintrag.getPid());

      shell.dispose();

    }
  
  }

  /**
   * Schliet den Dialog {@link EreignisKalenderDefinitionsdialog} ohne bernahme der Einstellungen.
   * 
   */
  private void aktionAbbrechen()
  {
    _eintrag = null;
    shell.dispose();
  }

  /**
   * Zeigt die Hilfe zum Dialog {@link EreignisKalenderDefinitionsdialog} an.
   * 
   */
  private void aktionHilfe()
  {
    String contextId = Aktivator.PLUGIN_ID + ".ereigniskalender";
    _debug.fine("ContextID: " + contextId);
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  /**
   * This method initializes composite
   * 
   */
  private void createComposite()
  {
    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.FILL;
    gridData21.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.FILL;
    gridData11.grabExcessHorizontalSpace = true;
    gridData11.verticalSpan = 3;
    gridData11.verticalAlignment = GridData.FILL;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    composite = new Composite(shell, SWT.NONE);
    composite.setLayoutData(gridData);
    composite.setLayout(gridLayout);
    labelName = new Label(composite, SWT.NONE);
    labelName.setText("Name");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData1);
    textName.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _name = textName.getText();

      }
    });
    labelBeschreibung = new Label(composite, SWT.NONE);
    labelBeschreibung.setText("Beschreibung");
    textArea = new Text(composite, SWT.MULTI | SWT.BORDER | SWT.WRAP | SWT.V_SCROLL);
    textArea.setLayoutData(gridData11);
    textArea.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _beschreibung = textArea.getText();

      }
    });
    Label filler2 = new Label(composite, SWT.NONE);
    Label filler3 = new Label(composite, SWT.NONE);
    labelTyp = new Label(composite, SWT.NONE);
    labelTyp.setText("EreignisTyp");
    combo2 = new Combo(composite, SWT.BORDER | SWT.READ_ONLY);
    combo2.setLayoutData(gridData21);
    combo2.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        IStructuredSelection structuredSelection = (IStructuredSelection)comboViewer2.getSelection();

        Object obj = structuredSelection.getFirstElement();

        if (obj instanceof SystemObject)
        {
          _ereignisTyp = (SystemObject)obj;

        }

      }
    });

    comboViewer2 = new ComboViewer(combo2);
    comboViewer2.setLabelProvider(new ILabelProvider() {
      @Override
      public Image getImage(Object element)
      {
        return null;
      }

      @Override
      public String getText(Object element)
      {
        String returnString = null;

        if (element instanceof SystemObject)
        {
          returnString = ((SystemObject)element).getName();
        }
        else if (element instanceof DummySystemObject)
        {

          returnString = ((DummySystemObject)element).getName();

        }
        return returnString;
      }

      @Override
      public void addListener(ILabelProviderListener listener)
      {
      }

      @Override
      public void dispose()
      {
      }

      @Override
      public boolean isLabelProperty(Object element, String property)
      {
        return false;
      }

      @Override
      public void removeListener(ILabelProviderListener listener)
      {
      }

    });
    List<SystemObject> list = holeEreignisTypen();
    for (SystemObject so : list)
    {
      comboViewer2.add(so);
    }

    labelQuelle = new Label(composite, SWT.NONE);
    labelQuelle.setText("Quelle");
    textQuelle = new Text(composite, SWT.BORDER);
    textQuelle.setLayoutData(gridData1);
    textQuelle.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _quelle = textQuelle.getText();

      }
    });

  }

  /**
   * This method initializes Filterdefintion
   * 
   */
  private void createFilterdefintion()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessVerticalSpace = false;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    groupFilterDefinitionen = new Group(shell, SWT.NONE);
    groupFilterDefinitionen.setLayout(new GridLayout());
    groupFilterDefinitionen.setLayoutData(gridData2);
    createComposite1();
    groupFilterDefinitionen.setText("Festlegung der zeitlichen Gltigkeit");
  }

  /**
   * This method initializes compositeFilterDef
   * 
   */
  private void createCompositeFilterDef()
  {

    GridData gridData9 = new GridData();
    gridData9.horizontalAlignment = GridData.FILL;
    gridData9.verticalAlignment = GridData.CENTER;
    GridData gridData7 = new GridData();
    gridData7.horizontalAlignment = GridData.FILL;
    gridData7.verticalAlignment = GridData.CENTER;
    GridData gridData6 = new GridData();
    gridData6.horizontalAlignment = GridData.FILL;
    gridData6.grabExcessHorizontalSpace = true;
    gridData6.verticalAlignment = GridData.CENTER;
    GridData gridData8 = new GridData();
    gridData8.horizontalAlignment = GridData.FILL;
    gridData8.grabExcessHorizontalSpace = true;
    gridData8.verticalAlignment = GridData.CENTER;

    compositeFilterDef.layout();

  }

  /**
   * This method initializes compositeBottom
   * 
   */
  private void createCompositeBottom()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(shell, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");
    buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOk();
			}			
		});

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionAbbrechen();
			}			
		});
    
    
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");
    buttonHilfe.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionHilfe();
			}			
		});
  }

  /**
   * This method initializes groupZeitspezifikation
   * 
   */
  private void createGroupZeitspezifikation()
  {
    GridLayout gridLayout4 = new GridLayout();
    gridLayout4.numColumns = 13;
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessVerticalSpace = false;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.verticalAlignment = GridData.CENTER;
    groupZeitspezifikation = new Group(shell, SWT.NONE);

    createCompositeZeitBereich();

    groupZeitspezifikation.setLayoutData(gridData4);
    Label filler4 = new Label(groupZeitspezifikation, SWT.NONE);
    createCompositeSyskal();
    groupZeitspezifikation.setLayout(gridLayout4);
    groupZeitspezifikation.setText("Zeitspezifikation");

    groupZeitspezifikation.layout();
  }

  /**
   * This method initializes compositeZeitSpec
   * 
   */
  private void createCompositeZeitBereich()
  {
    GridData gridData15 = new GridData();
    gridData15.horizontalSpan = 2;
    GridData gridData14 = new GridData();
    gridData14.horizontalAlignment = GridData.CENTER;
    gridData14.grabExcessHorizontalSpace = false;
    gridData14.verticalAlignment = GridData.CENTER;
    GridData gridData13 = new GridData();
    gridData13.horizontalSpan = 12;
    gridData13.horizontalAlignment = GridData.BEGINNING;
    gridData13.verticalAlignment = GridData.CENTER;
    gridData13.grabExcessHorizontalSpace = false;
    GridData gridData10 = new GridData();
    gridData10.horizontalAlignment = GridData.BEGINNING;
    gridData10.grabExcessHorizontalSpace = false;
    gridData10.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.BEGINNING;
    gridData11.grabExcessHorizontalSpace = false;
    gridData11.verticalAlignment = GridData.CENTER;

    GridLayout gridLayout2 = new GridLayout();
    gridLayout2.numColumns = 2;
    compositeZeitBereich = new Composite(groupZeitspezifikation, SWT.NONE);
    compositeZeitBereich.setLayout(gridLayout2);
    compositeZeitBereich.setLayoutData(gridData13);
    label4 = new Label(compositeZeitBereich, SWT.NONE);
    label4.setText("Ereignisbeginn");
    zeitVon = new DatumZeit(compositeZeitBereich, SWT.NONE, Eingabetyp.datumuhrEinfach, false, false);
    zeitVon.setLayoutData(gridData10);
    
    
//    textAnfangDatum = new Text(compositeZeitBereich, SWT.BORDER);
//    textAnfangDatum.setLayoutData(gridData15);
//    textAnfangZeit = new Text(compositeZeitBereich, SWT.BORDER);
//    textAnfangZeit.setLayoutData(gridData10);
    
    label5 = new Label(compositeZeitBereich, SWT.NONE);
    label5.setText("EreignisEnde");
    zeitBis = new DatumZeit(compositeZeitBereich, SWT.NONE, Eingabetyp.datumuhrEinfach, false, false);
    zeitBis.setLayoutData(gridData11);

//    textEndDatum = new Text(compositeZeitBereich, SWT.BORDER);
//    Label filler1 = new Label(compositeZeitBereich, SWT.NONE);
//    textEndZeit = new Text(compositeZeitBereich, SWT.BORDER);
//    textEndZeit.setLayoutData(gridData14);
    
  }

  /**
   * This method initializes compositeSyskal
   * 
   */
  private void createCompositeSyskal()
  {
    GridLayout gridLayout3 = new GridLayout();
    gridLayout3.numColumns = 4;
    GridData gridData5 = new GridData();
    gridData5.horizontalAlignment = GridData.FILL;
    gridData5.grabExcessHorizontalSpace = false;
    gridData5.horizontalSpan = 13;
    gridData5.verticalAlignment = GridData.CENTER;
    compositeSyskal = new Composite(groupZeitspezifikation, SWT.NONE);
    compositeSyskal.setLayoutData(gridData5);
    compositeSyskal.setLayout(gridLayout3);
    label = new Label(compositeSyskal, SWT.NONE);
    label.setText("Systemkalendereintrag");
    createCombo();
  }

  /**
   * This method initializes combo
   * 
   */
  private void createCombo()
  {
    GridData gridData12 = new GridData();
    gridData12.horizontalAlignment = GridData.FILL;
    gridData12.grabExcessHorizontalSpace = true;
    gridData12.horizontalSpan = 3;
    gridData12.grabExcessVerticalSpace = false;
    gridData12.verticalAlignment = GridData.CENTER;
    combo = new Combo(compositeSyskal, SWT.READ_ONLY);
    combo.setLayoutData(gridData12);
    combo.setEnabled(false);
    combo.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        IStructuredSelection structuredSelection = (IStructuredSelection)comboViewer.getSelection();

        Object obj = structuredSelection.getFirstElement();

        if (obj instanceof SystemObject)
        {
          _systemKalenderEintrag = (SystemObject)obj;
        }

      }
    });

    comboViewer = new ComboViewer(combo);
    comboViewer.setLabelProvider(new ILabelProvider() {
      @Override
      public Image getImage(Object element)
      {
        return null;
      }

      @Override
      public String getText(Object element)
      {
        String returnString = null;
        if (element instanceof SystemObject)
        {
          returnString = ((SystemObject)element).getName();
        }
        else if (element instanceof DummySystemObject)
        {

          returnString = ((DummySystemObject)element).getName();
        }

        return returnString;
      }

      @Override
      public void addListener(ILabelProviderListener listener)
      {
      }

      @Override
      public void dispose()
      {
      }

      @Override
      public boolean isLabelProperty(Object element, String property)
      {
        return false;
      }

      @Override
      public void removeListener(ILabelProviderListener listener)
      {
      }

    });
    List<SystemObject> list = holeSystemKalenderEintraege();
    for (SystemObject so : list)
    {
      comboViewer.add(so);
    }

  }

  /**
   * This method initializes composite1
   * 
   */
  private void createComposite1()
  {
    composite1 = new Composite(groupFilterDefinitionen, SWT.NONE);
    composite1.setLayout(new FillLayout());
    createCompositeFilterDef2();
  }

  /**
   * This method initializes compositeFilterDef
   * 
   */
  private void createCompositeFilterDef2()
  {
    GridData gridData101 = new GridData();
    gridData101.horizontalAlignment = GridData.CENTER;
    gridData101.grabExcessHorizontalSpace = false;
    gridData101.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout1 = new GridLayout();
    gridLayout1.numColumns = 2;
    gridLayout1.marginHeight = 5;
    gridLayout1.marginWidth = 5;
    gridLayout1.verticalSpacing = 5;
    compositeFilterDef = new Composite(composite1, SWT.NONE);
    compositeFilterDef.setLayout(gridLayout1);
    radioButton1 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton1.setSelection(true);
    // _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe);
    radioButton1.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton1.getSelection())
        {
          _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe);
//          textAnfangDatum.setEnabled(true);
//          textAnfangZeit.setEnabled(true);
//          textEndDatum.setEnabled(true);
//          textEndZeit.setEnabled(true);
          zeitVon.setEnabled(true);
          zeitBis.setEnabled(true);
       
          combo.setEnabled(false);

        }

      }

    });
    label1 = new Label(compositeFilterDef, SWT.NONE);
    label1.setText("Zeitbereichseingabe");
    radioButton2 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton2.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton2.getSelection())
        {
          _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Systemkalendereintrag);
          combo.setEnabled(true);
//          textAnfangDatum.setEnabled(false);
//          textAnfangZeit.setEnabled(false);
//          textEndDatum.setEnabled(false);
//          textEndZeit.setEnabled(false);
          zeitVon.setEnabled(false);
          zeitBis.setEnabled(false);
        }

      }

    });
    label2 = new Label(compositeFilterDef, SWT.NONE);
    label2.setText("Systemkalendereintrag");
    label2.setLayoutData(gridData101);
  }

  /**
   * This method initializes groupVerkehrlich
   * 
   */
  private void createGroupVerkehrlich()
  {
    GridLayout gridLayout6 = new GridLayout();
    gridLayout6.numColumns = 1;
    GridData gridData16 = new GridData();
    gridData16.horizontalAlignment = GridData.FILL;
    gridData16.grabExcessHorizontalSpace = true;
    gridData16.grabExcessVerticalSpace = true;
    gridData16.verticalAlignment = GridData.FILL;
    groupVerkehrlich = new Group(shell, SWT.NONE);
    groupVerkehrlich.setText("Verkehrliche Gltigkeit");
    createComposite2();
    groupVerkehrlich.setLayout(gridLayout6);
    groupVerkehrlich.setLayoutData(gridData16);
  }

  /**
   * This method initializes composite2
   * 
   */
  private void createComposite2()
  {
    GridLayout gridLayout5 = new GridLayout();
    gridLayout5.numColumns = 2;
    GridData gridData17 = new GridData();
    gridData17.horizontalAlignment = GridData.FILL;
    gridData17.grabExcessHorizontalSpace = true;
    gridData17.grabExcessVerticalSpace = true;
    gridData17.verticalAlignment = GridData.FILL;
    composite2 = new Composite(groupVerkehrlich, SWT.NONE);
    composite2.setLayoutData(gridData17);
    composite2.setLayout(gridLayout5);
    createCompositeTabelleVk();
    createCompositeRechts();
  }

  private void erzeugeTabelle()
  {

    _tvVerkehrlich = new TableViewer(compositeTabelleVk, SWT.BORDER | SWT.FULL_SELECTION | SWT.H_SCROLL | SWT.V_SCROLL);

    final TableColumn tc0 = new TableColumn(_tvVerkehrlich.getTable(), SWT.LEFT | SWT.Move);
    tc0.setText("von");
    tc0.setWidth(90);
    tc0.setMoveable(true);
    tc0.addListener(SWT.Selection, new Listener() {
      private int colPos = 0;

      private boolean sortFlag = false;

      public void handleEvent(Event event)
      {
        sortFlag = !sortFlag;
        Table table = _tvVerkehrlich.getTable();

        BaseComapator[][] comparables = new BaseComapator[table.getColumnCount()][table.getItemCount()];

        for (int i = 0; i < table.getItemCount(); i++)
        {
          TableItem item = table.getItem(i);

          String[] strings = new String[table.getColumnCount()];
          for (int j = 0; j < table.getColumnCount(); j++)
          {
            String text = item.getText(j);
            strings[j] = text;
          }

          // comparables[colPos][i] = new StringComparator(strings, i, colPos);
        }

        // sortTable(table, table.getItems(), colPos, comparables, sortFlag);
      }

    });

    TableColumn tc1 = new TableColumn(_tvVerkehrlich.getTable(), SWT.LEFT | SWT.Move);
    tc1.setText("Bezug");
    tc1.setWidth(90);
    tc1.setMoveable(true);
    tc1.addListener(SWT.Selection, new Listener() {
      private int colPos = 1;

      private boolean sortFlag = false;

      public void handleEvent(Event event)
      {
        sortFlag = !sortFlag;
        Table table = _tvVerkehrlich.getTable();

        BaseComapator[][] comparables = new BaseComapator[table.getColumnCount()][table.getItemCount()];

        for (int i = 0; i < table.getItemCount(); i++)
        {
          TableItem item = table.getItem(i);

          String[] strings = new String[table.getColumnCount()];
          for (int j = 0; j < table.getColumnCount(); j++)
          {
            String text = item.getText(j);
            strings[j] = text;
          }

          // comparables[colPos][i] = new StringComparator(strings, i, colPos);
        }

        // sortTable(table, table.getItems(), colPos, comparables, sortFlag);
      }

    });

    TableColumn tc2 = new TableColumn(_tvVerkehrlich.getTable(), SWT.LEFT | SWT.Move);
    tc2.setText("bis");
    tc2.setWidth(90);
    tc2.setMoveable(true);
    tc2.addListener(SWT.Selection, new Listener() {
      private int colPos = 1;

      private boolean sortFlag = false;

      public void handleEvent(Event event)
      {
        sortFlag = !sortFlag;
        Table table = _tvVerkehrlich.getTable();

        BaseComapator[][] comparables = new BaseComapator[table.getColumnCount()][table.getItemCount()];

        for (int i = 0; i < table.getItemCount(); i++)
        {
          TableItem item = table.getItem(i);

          String[] strings = new String[table.getColumnCount()];
          for (int j = 0; j < table.getColumnCount(); j++)
          {
            String text = item.getText(j);
            strings[j] = text;
          }

          // comparables[colPos][i] = new StringComparator(strings, i, colPos);
        }

        // sortTable(table, table.getItems(), colPos, comparables, sortFlag);
      }

    });

    TableColumn tc3 = new TableColumn(_tvVerkehrlich.getTable(), SWT.LEFT | SWT.Move);
    tc3.setText("Bezug");
    tc3.setWidth(90);
    tc3.setMoveable(true);
    tc3.addListener(SWT.Selection, new Listener() {
      private int colPos = 1;

      private boolean sortFlag = false;

      public void handleEvent(Event event)
      {
        sortFlag = !sortFlag;
        Table table = _tvVerkehrlich.getTable();

        BaseComapator[][] comparables = new BaseComapator[table.getColumnCount()][table.getItemCount()];

        for (int i = 0; i < table.getItemCount(); i++)
        {
          TableItem item = table.getItem(i);

          String[] strings = new String[table.getColumnCount()];
          for (int j = 0; j < table.getColumnCount(); j++)
          {
            String text = item.getText(j);
            strings[j] = text;
          }

          // comparables[colPos][i] = new StringComparator(strings, i, colPos);
        }

        // sortTable(table, table.getItems(), colPos, comparables, sortFlag);
      }

    });

    _tvVerkehrlich.getTable().setHeaderVisible(true);
    _tvVerkehrlich.getTable().setLinesVisible(true);

    _tvVerkehrlich.setContentProvider(new TabelleInhaltsVersorger());
    _tvVerkehrlich.setLabelProvider(new TabelleDarstellungsVersorgerVg());

    _tvVerkehrlich.addSelectionChangedListener(new ISelectionChangedListener() {
      public void selectionChanged(SelectionChangedEvent event)
      {
        IStructuredSelection selection = (IStructuredSelection)event.getSelection();
        Object firstElement = selection.getFirstElement();

        if (firstElement instanceof EintragVerkehrlicheGueltigkeit)
        {
          _eintragVerkehrlicheGueltigkeit = (EintragVerkehrlicheGueltigkeit)firstElement;

        }else
          _eintragVerkehrlicheGueltigkeit = null;
      }

    });

  }

  private class TabelleInhaltsVersorger implements IStructuredContentProvider
  {
    public Object[] getElements(Object inputElement)
    {

      java.util.List list = (java.util.List)inputElement;

      Object[] objects = new Object[list.size()];

      for (int i = 0; i < list.size(); i++)
      {
        objects[i] = list.get(i);

      }

      return objects;

    }

    public void dispose()
    {
    }

    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {
    }

  }

  private class TabelleDarstellungsVersorgerVg implements ITableLabelProvider
  {

    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    public String getColumnText(Object object, int columnIndex)
    {
      String returnString = null;
      Calendar cal = new GregorianCalendar();

      Formatter fmtr = new Formatter();
      Formatter format = null;
      int hour = 0;

      switch (columnIndex)
      {
        case 0:
          long von = ((EintragVerkehrlicheGueltigkeit)object).getVon();
          cal.setTimeInMillis(von);

          if (cal.get(Calendar.HOUR) != 0)
            hour = cal.get(Calendar.HOUR) - 1;
          else
            hour = cal.get(Calendar.HOUR);

          format = fmtr.format("%1$02d:%2$02d", hour, cal.get(Calendar.MINUTE));
          returnString = format.toString();
          break;

        case 1:
          returnString = ((EintragVerkehrlicheGueltigkeit)object).getVonBezugszeitpunkt().toString();
          break;
        case 2:
          long bis = ((EintragVerkehrlicheGueltigkeit)object).getBis();
          cal.setTimeInMillis(bis);

          if (cal.get(Calendar.HOUR) != 0)
            hour = cal.get(Calendar.HOUR) - 1;
          else
            hour = cal.get(Calendar.HOUR);

          format = fmtr.format("%1$02d:%2$02d", hour, cal.get(Calendar.MINUTE));
          returnString = format.toString();
          break;
        case 3:
          returnString = ((EintragVerkehrlicheGueltigkeit)object).getBisBezugszeitpunkt().toString();
          break;

        default:
          returnString = "";

      }

      return returnString;
    }

    public void addListener(ILabelProviderListener listener)
    {
    }

    public void dispose()
    {
    }

    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    public void removeListener(ILabelProviderListener listener)
    {
    }

  }

  private class TabelleDarstellungsVersorgerRg implements ITableLabelProvider
  {

    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    public String getColumnText(Object object, int columnIndex)
    {
      String returnString = null;

      switch (columnIndex)
      {
        case 0:
          returnString = ((EintragRaeumlicheGueltigkeit)object).getName();
          break;
        case 1:
          returnString = ((EintragRaeumlicheGueltigkeit)object).getInfo();
          break;

        default:
          returnString = "";
      }

      return returnString;
    }

    public void addListener(ILabelProviderListener listener)
    {
    }

    public void dispose()
    {
    }

    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    public void removeListener(ILabelProviderListener listener)
    {
    }

  }

  /**
   * This method initializes compositeTabelleVk
   * 
   */
  private void createCompositeTabelleVk()
  {
    GridData gridData19 = new GridData();
    gridData19.horizontalAlignment = GridData.FILL;
    gridData19.grabExcessHorizontalSpace = true;
    gridData19.grabExcessVerticalSpace = true;
    gridData19.verticalAlignment = GridData.FILL;
    compositeTabelleVk = new Composite(composite2, SWT.NONE);
    compositeTabelleVk.setLayout(new FillLayout());
    compositeTabelleVk.setLayoutData(gridData19);
    erzeugeTabelle();
  }

  private void createCompositeRight()
  {
    GridData gridData24 = new GridData();
    gridData24.horizontalAlignment = GridData.FILL;
    gridData24.grabExcessHorizontalSpace = true;
    gridData24.verticalAlignment = GridData.CENTER;
    GridData gridData25 = new GridData();
    gridData25.horizontalAlignment = GridData.FILL;
    gridData25.grabExcessHorizontalSpace = true;
    gridData25.verticalAlignment = GridData.CENTER;
    RowLayout rowLayout2 = new RowLayout();
    rowLayout2.type = org.eclipse.swt.SWT.VERTICAL;
    rowLayout2.wrap = false;
    rowLayout2.pack = false;
    GridData gridData6 = new GridData();
    gridData6.horizontalAlignment = GridData.CENTER;
    gridData6.grabExcessVerticalSpace = true;
    gridData6.verticalAlignment = GridData.FILL;

    buttonNeu1 = new Button(compositeRechts, SWT.NONE);
    buttonNeu1.setText("Neu...");
    buttonNeu1.setLayoutData(gridData24);
    
    buttonNeu1.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
        DefinitionVerkehrlicheGueltigkeit definitionVerkehrlicheGueltigkeit = new DefinitionVerkehrlicheGueltigkeit(
            PlatformUI.getWorkbench().getDisplay().getActiveShell());
        EintragVerkehrlicheGueltigkeit eintrag = definitionVerkehrlicheGueltigkeit.oeffne();

        if (eintrag != null){
          
          if (!_lEintragVerkehrlicheGueltigkeit.contains(eintrag))
            _lEintragVerkehrlicheGueltigkeit.add(eintrag);
  
          _tvVerkehrlich.setInput(_lEintragVerkehrlicheGueltigkeit);
          
        }
			}			
		});

    buttonBearbeiten1 = new Button(compositeRechts, SWT.NONE);
    buttonBearbeiten1.setText("Lschen");
    buttonBearbeiten1.setLayoutData(gridData25);    
    buttonBearbeiten1.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
       if (_eintragVerkehrlicheGueltigkeit != null){        
         
          _lEintragVerkehrlicheGueltigkeit.remove(_eintragVerkehrlicheGueltigkeit);  
          _tvVerkehrlich.setInput(_lEintragVerkehrlicheGueltigkeit);
          
       }else{
         MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
         mb.setText("Fehler");
         mb.setMessage("Es muss ein Eintrag ausgewhlt werden!");
         mb.open();
         return;
       }
			}			
		});
  }

  /**
   * This method initializes compositeRechts
   * 
   */
  private void createCompositeRechts()
  {
    GridData gridData18 = new GridData();
    gridData18.horizontalAlignment = GridData.FILL;
    gridData18.grabExcessHorizontalSpace = true;
    gridData18.grabExcessVerticalSpace = true;
    gridData18.verticalAlignment = GridData.FILL;
    compositeRechts = new Composite(composite2, SWT.NONE);
    compositeRechts.setLayout(new GridLayout());
    compositeRechts.setLayoutData(gridData18);
    createCompositeRight();
  }

  /**
   * This method initializes groupRaeumlich
   * 
   */
  private void createGroupRaeumlich()
  {
    GridData gridData20 = new GridData();
    gridData20.horizontalAlignment = GridData.FILL;
    gridData20.grabExcessHorizontalSpace = true;
    gridData20.grabExcessVerticalSpace = true;
    gridData20.verticalAlignment = GridData.FILL;
    GridLayout gridLayout61 = new GridLayout();
    gridLayout61.numColumns = 1;
    groupRaeumlich = new Group(shell, SWT.NONE);
    groupRaeumlich.setText("Rumliche Gltigkeit");
    groupRaeumlich.setLayout(gridLayout61);
    groupRaeumlich.setLayoutData(gridData20);
    createComposite21();
  }

  /**
   * This method initializes composite21
   * 
   */
  private void createComposite21()
  {
    GridLayout gridLayout51 = new GridLayout();
    gridLayout51.numColumns = 2;
    GridData gridData171 = new GridData();
    gridData171.horizontalAlignment = GridData.FILL;
    gridData171.grabExcessHorizontalSpace = true;
    gridData171.grabExcessVerticalSpace = true;
    gridData171.verticalAlignment = GridData.FILL;
    composite21 = new Composite(groupRaeumlich, SWT.NONE);
    composite21.setLayoutData(gridData171);
    createCompositeTabelleVk1();
    composite21.setLayout(gridLayout51);
    createCompositeRechts1();
  }

  /**
   * This method initializes compositeTabelleVk1
   * 
   */
  private void createCompositeTabelleVk1()
  {
    GridData gridData191 = new GridData();
    gridData191.horizontalAlignment = GridData.FILL;
    gridData191.grabExcessHorizontalSpace = true;
    gridData191.grabExcessVerticalSpace = true;
    gridData191.verticalAlignment = GridData.FILL;
    compositeTabelleVk1 = new Composite(composite21, SWT.NONE);
    compositeTabelleVk1.setLayout(new FillLayout());
    compositeTabelleVk1.setLayoutData(gridData191);
    erzeugeTabelle1();
  }

  /**
   * This method initializes compositeRechts1
   * 
   */
  private void createCompositeRechts1()
  {
    GridData gridData23 = new GridData();
    gridData23.horizontalAlignment = GridData.FILL;
    gridData23.grabExcessHorizontalSpace = true;
    gridData23.verticalAlignment = GridData.CENTER;
    GridData gridData22 = new GridData();
    gridData22.horizontalAlignment = GridData.FILL;
    gridData22.grabExcessHorizontalSpace = true;
    gridData22.verticalAlignment = GridData.CENTER;
    GridData gridData181 = new GridData();
    gridData181.horizontalAlignment = GridData.FILL;
    gridData181.grabExcessHorizontalSpace = true;
    gridData181.grabExcessVerticalSpace = true;
    gridData181.verticalAlignment = GridData.FILL;
    compositeRechts1 = new Composite(composite21, SWT.NONE);
    compositeRechts1.setLayout(new GridLayout());
    compositeRechts1.setLayoutData(gridData181);
    buttonNeu11 = new Button(compositeRechts1, SWT.NONE);
    buttonNeu11.setText("Neu...");
    buttonNeu11.setLayoutData(gridData22);    
    buttonNeu11.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
        // aktionLoeschen();
        DefinitionRaeumlicheGueltigkeit definitionRaeumlicheGueltigkeit = new DefinitionRaeumlicheGueltigkeit(
            PlatformUI.getWorkbench().getDisplay().getActiveShell());
        EintragRaeumlicheGueltigkeit eintrag = definitionRaeumlicheGueltigkeit.oeffne();
        
        if (eintrag != null){

          if (!_lEintragRaeumlicheGueltigkeit.contains(eintrag))
            _lEintragRaeumlicheGueltigkeit.add(eintrag);
  
          _tvRaeumlich.setInput(_lEintragRaeumlicheGueltigkeit);
        
        }
			}			
		});

    buttonBearbeiten11 = new Button(compositeRechts1, SWT.NONE);
    buttonBearbeiten11.setText("Lschen");
    buttonBearbeiten11.setLayoutData(gridData23);    
    buttonBearbeiten11.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
        // aktionLoeschen();

       
        if (_eintragRaeumlicheGueltigkeit != null){
        
          _lEintragRaeumlicheGueltigkeit.remove(_eintragRaeumlicheGueltigkeit);
  
          _tvRaeumlich.setInput(_lEintragRaeumlicheGueltigkeit);
        
        }else{
          MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
          mb.setText("Fehler");
          mb.setMessage("Es muss ein Eintrag ausgewhlt werden!");
          mb.open();
          return;
        }
			}			
		});
  }

  private void erzeugeTabelle1()
  {

    _tvRaeumlich = new TableViewer(compositeTabelleVk1, SWT.BORDER | SWT.FULL_SELECTION | SWT.H_SCROLL | SWT.V_SCROLL);

    final TableColumn tc0 = new TableColumn(_tvRaeumlich.getTable(), SWT.LEFT | SWT.Move);
    tc0.setText("Name");
    tc0.setWidth(180);
    tc0.setMoveable(true);
    tc0.addListener(SWT.Selection, new Listener() {
      private int colPos = 0;

      private boolean sortFlag = false;

      public void handleEvent(Event event)
      {
        sortFlag = !sortFlag;
        Table table = _tvRaeumlich.getTable();

        BaseComapator[][] comparables = new BaseComapator[table.getColumnCount()][table.getItemCount()];

        for (int i = 0; i < table.getItemCount(); i++)
        {
          TableItem item = table.getItem(i);

          String[] strings = new String[table.getColumnCount()];
          for (int j = 0; j < table.getColumnCount(); j++)
          {
            String text = item.getText(j);
            strings[j] = text;
          }

          // comparables[colPos][i] = new StringComparator(strings, i, colPos);
        }

        // sortTable(table, table.getItems(), colPos, comparables, sortFlag);
      }

    });

    TableColumn tc1 = new TableColumn(_tvRaeumlich.getTable(), SWT.LEFT | SWT.Move);
    tc1.setText("Info");
    tc1.setWidth(180);
    tc1.setMoveable(true);
    tc1.addListener(SWT.Selection, new Listener() {
      private int colPos = 1;

      private boolean sortFlag = false;

      public void handleEvent(Event event)
      {
        sortFlag = !sortFlag;
        Table table = _tvRaeumlich.getTable();

        BaseComapator[][] comparables = new BaseComapator[table.getColumnCount()][table.getItemCount()];

        for (int i = 0; i < table.getItemCount(); i++)
        {
          TableItem item = table.getItem(i);

          String[] strings = new String[table.getColumnCount()];
          for (int j = 0; j < table.getColumnCount(); j++)
          {
            String text = item.getText(j);
            strings[j] = text;
          }

          // comparables[colPos][i] = new StringComparator(strings, i, colPos);
        }

        // sortTable(table, table.getItems(), colPos, comparables, sortFlag);
      }

    });

    _tvRaeumlich.getTable().setHeaderVisible(true);
    _tvRaeumlich.getTable().setLinesVisible(true);

    _tvRaeumlich.setContentProvider(new TabelleInhaltsVersorger());
    _tvRaeumlich.setLabelProvider(new TabelleDarstellungsVersorgerRg());

    _tvRaeumlich.addSelectionChangedListener(new ISelectionChangedListener() {
      public void selectionChanged(SelectionChangedEvent event)
      {
        IStructuredSelection selection = (IStructuredSelection)event.getSelection();
        Object firstElement = selection.getFirstElement();

        if (firstElement instanceof EintragRaeumlicheGueltigkeit)
        {
          _eintragRaeumlicheGueltigkeit = (EintragRaeumlicheGueltigkeit)firstElement;
        }else
          _eintragRaeumlicheGueltigkeit = null;

      }

    });

  }

  private List<SystemObject> holeSystemKalenderEintraege()
  {

    ConfigurationAuthority konfigurationsObjekt = DaVKommunikation.getInstanz().holeDaVVerbindung()
        .getLocalConfigurationAuthority();

    ObjectSet objekte = konfigurationsObjekt.getObjectSet("SystemKalenderEintrge");

    List<SystemObject> list = objekte.getElements();

    List<SystemObject> listTmp = new ArrayList<SystemObject>();
    for (SystemObject systemObject : list)
    {
      if (!systemObject.isValid())
      {

        listTmp.add(systemObject);
      }
    }
    // list.removeAll(listTmp);

    return list;

  }

  private List<SystemObject> holeEreignisTypen()
  {

    ConfigurationAuthority konfigurationsObjekt = DaVKommunikation.getInstanz().holeDaVVerbindung()
        .getLocalConfigurationAuthority();

    ObjectSet objekte = konfigurationsObjekt.getObjectSet("EreignisTypen");

    List<SystemObject> list = objekte.getElements();

    List<SystemObject> listTmp = new ArrayList<SystemObject>();
    for (SystemObject systemObject : list)
    {
      if (!systemObject.isValid())
      {

        listTmp.add(systemObject);
      }
    }
    // list.removeAll(listTmp);

    return list;

  }

  private class DummySystemObject implements SystemObject
  {

    private String _name = null;

    public DummySystemObject()
    {
      _name = "undefiniert";
    }

    @Override
    public ConfigurationArea getConfigurationArea()
    {
      return null;
    }

    @Override
    public Data getConfigurationData(AttributeGroup atg)
    {
      return null;
    }

    @Override
    public Data getConfigurationData(AttributeGroupUsage atgUsage)
    {
      return null;
    }

    @Override
    public Data getConfigurationData(AttributeGroup atg, Aspect asp)
    {
      return null;
    }

    @Override
    public DataModel getDataModel()
    {
      return null;
    }

    @Override
    public long getId()
    {
      return 0;
    }

    @Override
    public SystemObjectInfo getInfo()
    {
      return null;
    }

    @Override
    public String getName()
    {
      return _name;
    }

    @Override
    public String getNameOrPidOrId()
    {
      return null;
    }

    @Override
    public String getPid()
    {
      return null;
    }

    @Override
    public String getPidOrId()
    {
      return null;
    }

    @Override
    public String getPidOrNameOrId()
    {
      return null;
    }

    @Override
    public SystemObjectType getType()
    {
      return null;
    }

    @Override
    public Collection<AttributeGroupUsage> getUsedAttributeGroupUsages()
    {
      return null;
    }

    @Override
    public void invalidate() throws ConfigurationChangeException
    {
    }

    @Override
    public boolean isOfType(SystemObjectType type)
    {
      return false;
    }

    @Override
    public boolean isOfType(String typePid)
    {
      return false;
    }

    @Override
    public boolean isValid()
    {
      return false;
    }

    @Override
    public void setConfigurationData(AttributeGroup atg, Data data) throws ConfigurationChangeException
    {
    }

    @Override
    public void setConfigurationData(AttributeGroupUsage atgUsage, Data data) throws ConfigurationChangeException
    {
    }

    @Override
    public void setConfigurationData(AttributeGroup atg, Aspect asp, Data data) throws ConfigurationChangeException
    {
    }

    @Override
    public void setName(String name) throws ConfigurationChangeException
    {

    }

    @Override
    public int compareTo(Object o)
    {
      return 0;
    }

  }

}
