/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw.listendarstellung;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Button;

import de.bsvrz.buv.rw.basislib.listendarstellung.EnumDarstellungsArt;
import de.bsvrz.buv.rw.basislib.listendarstellung.ListenDarstellungDialog;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.ClientDavInterface;

public class TestSichtListenDarstellung extends ViewPart
{

	public static final String ID = "de.bsvrz.buv.plugin.pruefrw.listendarstellung.TestSichtListenDarstellung";

	private Composite top = null;
	private Label labelObjektTyp = null;
	private Label labelAttributgruppe = null;
	private Label labelAspekt = null;
	private Label labelSystemObjekt = null;
	private Text textObjTyp = null;
	private Text textAtg = null;
	private Text textAsp = null;
	private Text textSystemObjekt = null;
	private Label labelDarstellungsArt = null;
	private Combo comboDarstellungsArt = null;
	private ComboViewer comboViewer = null;
	private Button buttonOeffnen = null;

	@Override
	public void createPartControl(Composite parent)
	{
		GridData gridData5 = new GridData();
		gridData5.grabExcessHorizontalSpace = true;
		gridData5.verticalAlignment = GridData.CENTER;
		gridData5.horizontalAlignment = GridData.FILL;
		GridData gridData3 = new GridData();
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.verticalAlignment = GridData.CENTER;
		gridData3.horizontalAlignment = GridData.FILL;
		GridData gridData2 = new GridData();
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		gridData2.horizontalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.CENTER;
		gridData1.horizontalAlignment = GridData.FILL;
		GridData gridData = new GridData();
		gridData.grabExcessHorizontalSpace = true;
		gridData.verticalAlignment = GridData.CENTER;
		gridData.horizontalAlignment = GridData.FILL;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		top = new Composite(parent, SWT.NONE);
		top.setLayout(gridLayout);
		labelObjektTyp = new Label(top, SWT.NONE);
		labelObjektTyp.setText("Objekt Typ:");
		textObjTyp = new Text(top, SWT.BORDER);
		textObjTyp.setLayoutData(gridData);
		labelAttributgruppe = new Label(top, SWT.NONE);
		labelAttributgruppe.setText("Attributgruppe:");
		textAtg = new Text(top, SWT.BORDER);
		textAtg.setLayoutData(gridData1);
		labelAspekt = new Label(top, SWT.NONE);
		labelAspekt.setText("Aspekt:");
		textAsp = new Text(top, SWT.BORDER);
		textAsp.setLayoutData(gridData2);
		labelSystemObjekt = new Label(top, SWT.NONE);
		labelSystemObjekt.setText("SystemObjekt:");
		textSystemObjekt = new Text(top, SWT.BORDER);
		textSystemObjekt.setLayoutData(gridData3);
		labelDarstellungsArt = new Label(top, SWT.NONE);
		labelDarstellungsArt.setText("Darstellungs Art:");
		createComboDarstellungsArt();

		@SuppressWarnings("unused")
		Label filler = new Label(top, SWT.NONE);

		buttonOeffnen = new Button(top, SWT.NONE);
		buttonOeffnen.setText("ffnen");
		buttonOeffnen.setLayoutData(gridData5);
		buttonOeffnen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOeffneListenDarstellung();
			}			
		});

		textObjTyp.setText("typ.autarkeOrganisationsEinheit");
		textAtg.setText("atg.oberflchenBerechtigung");
		textAsp.setText("asp.parameterSoll");
		textSystemObjekt.setText("kv.testKonfiguration");
	}

	private void aktionOeffneListenDarstellung()
	{
		ClientDavInterface dav = DaVVerbindung.getInstanz().getDaVVerbindung();
		if (dav != null)
		{

			String objTyp = textObjTyp.getText();
			String atg = textAtg.getText();
			String asp = textAsp.getText();
			String pidSystemObjekt = textSystemObjekt.getText();

			EnumDarstellungsArt darstellungsArt = null;

			StructuredSelection ssCombo = (StructuredSelection) comboViewer
					.getSelection();
			Object firstElement = ssCombo.getFirstElement();
			if (firstElement instanceof EnumDarstellungsArt)
			{
				darstellungsArt = (EnumDarstellungsArt) firstElement;
			}

			ListenDarstellungDialog ldd = new ListenDarstellungDialog(
					(ClientDavConnection) DaVVerbindung.getInstanz().getDaVVerbindung());
		
			@SuppressWarnings("unused")
			boolean open = ldd.open(pidSystemObjekt, objTyp, atg, asp,
					darstellungsArt);
		} else
		{
			MessageBox mb = new MessageBox(PlatformUI.getWorkbench().getDisplay()
					.getActiveShell(), SWT.OK | SWT.ICON_ERROR);
			mb.setText("Keine Verbindung zu einem DaV vorhanden!");
			mb
					.setMessage("Es ist zur Zeit keine Verbindung zu einem DaV aktiv. Fhre die Aktion nicht aus.");
			@SuppressWarnings("unused")
			int wert = mb.open();
		}
	}

	@Override
	public void setFocus()
	{

	}

	/**
	 * This method initializes comboDarstellungsArt
	 * 
	 */
	private void createComboDarstellungsArt()
	{
		GridData gridData4 = new GridData();
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.verticalAlignment = GridData.CENTER;
		comboDarstellungsArt = new Combo(top, SWT.NONE);
		comboDarstellungsArt.setLayoutData(gridData4);
		comboViewer = new ComboViewer(comboDarstellungsArt);

		Object[] darstellungsArten = new Object[] {
				EnumDarstellungsArt.zustandsDarstellung,
				EnumDarstellungsArt.aenderungsDarstellung };

		comboViewer.add(darstellungsArten);

		comboViewer.setSelection(new StructuredSelection(
				EnumDarstellungsArt.zustandsDarstellung));

	}

} // @jve:decl-index=0:visual-constraint="10,10,306,281"
