/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw.sonstiges;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.plugin.pruefrw.Saver;

public class Sonstiges extends ViewPart
{

	public static final String ID = "de.bsvrz.buv.plugin.pruefrw.sonstiges.Sonstiges"; 
	
	private Composite top = null;
	private Group gruppeSonstiges = null;
	private Label labelTimeOut = null;
	private Text textZeitspanneVorBeenden = null;
	private Button schaltflaecheUebernehmen = null;

	private void aktionUebernehmen()
	{
		String text = textZeitspanneVorBeenden.getText();
		try
		{
			int wert = Integer.valueOf(text);
			Saver.setTimeOut(wert);
		} catch (NumberFormatException nfe)
		{
			MessageBox msb = new MessageBox(PlatformUI.getWorkbench().getDisplay().getActiveShell(), SWT.OK |SWT.ICON_INFORMATION);
			msb.setText("Keine Zahl eingegeben");
			msb.setMessage("Sie mssen eine Zahl eingeben!");
			msb.open();
		}
	}

	@Override
	public void createPartControl(Composite parent)
	{
		top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout());
		createGruppeSonstiges();
	}

	@Override
	public void setFocus()
	{
	}

	/**
	 * This method initializes gruppeSonstiges
	 * 
	 */
	private void createGruppeSonstiges()
	{
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		gruppeSonstiges = new Group(top, SWT.NONE);
		gruppeSonstiges.setLayoutData(gridData);
		gruppeSonstiges.setLayout(gridLayout);
		gruppeSonstiges.setText("Sonstige Aktionen:");
		labelTimeOut = new Label(gruppeSonstiges, SWT.NONE);
		labelTimeOut.setText("Zeitspanne Beenden:");
		textZeitspanneVorBeenden = new Text(gruppeSonstiges, SWT.BORDER);
		textZeitspanneVorBeenden.setToolTipText("Zeitspanne in Millisekunden, die das Beenden des Rahmenwerkes knstlich verlngert wird.");
		textZeitspanneVorBeenden.setText("3000");
		textZeitspanneVorBeenden.setLayoutData(gridData1);
		schaltflaecheUebernehmen = new Button(gruppeSonstiges, SWT.NONE);
		schaltflaecheUebernehmen.setText("bernehmen");
		schaltflaecheUebernehmen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionUebernehmen();
			}			
		});
	}

}
