/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw.urlasserdialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.rw.basislib.login.UrlasserDialog;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;

public class SichtUrlasserDialogTest extends ViewPart implements Runnable
{

	/**
	 * ViewID
	 */
	public static final String ID = "de.bsvrz.buv.plugin.pruefrw.urlasserdialog.SichtUrlasserDialogTest";
	private Composite top = null;
	private Group gruppeOben = null;
	private Composite compositeUnten = null;
	private Composite compositeUntenRechts = null;
	private Button schaltflaecheOk = null;
	private Label labelDaVIp = null;
	private Label labelDaVPort = null;
	private Text textDaVAdresse = null;
	private Text textDaVPort = null;
	private Button buttonUrlasser = null;

	/**
	 * Thread-Flag
	 */
	private boolean _laufeThread = false;

	@Override
	public void createPartControl(Composite parent)
	{
		top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout());
		createGruppeOben();
		createCompositeUnten();

		// startThread();
	}

	@Override
	public void setFocus()
	{
	}

	@Override
	public void dispose()
	{
		stopThread();
		super.dispose();
	}

	/**
	 * This method initializes gruppeOben
	 * 
	 */
	private void createGruppeOben()
	{
		GridData gridData21 = new GridData();
		gridData21.horizontalAlignment = GridData.FILL;
		gridData21.grabExcessHorizontalSpace = true;
		gridData21.verticalAlignment = GridData.CENTER;
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.FILL;
		gridData11.grabExcessHorizontalSpace = true;
		gridData11.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		gruppeOben = new Group(top, SWT.NONE);
		gruppeOben.setLayoutData(gridData);
		gruppeOben.setLayout(gridLayout);
		gruppeOben.setText("bersicht");
		labelDaVIp = new Label(gruppeOben, SWT.NONE);
		labelDaVIp.setText("DaV Adresse:");
		textDaVAdresse = new Text(gruppeOben, SWT.BORDER);
		textDaVAdresse.setEditable(false);
		textDaVAdresse.setLayoutData(gridData11);
		labelDaVPort = new Label(gruppeOben, SWT.NONE);
		labelDaVPort.setText("DaV Port:");
		textDaVPort = new Text(gruppeOben, SWT.BORDER);
		textDaVPort.setEditable(false);
		textDaVPort.setLayoutData(gridData21);
	}

	/**
	 * This method initializes compositeUnten
	 * 
	 */
	private void createCompositeUnten()
	{
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.CENTER;
		compositeUnten = new Composite(top, SWT.NONE);
		compositeUnten.setLayout(new GridLayout());
		createCompositeUntenRechts();
		compositeUnten.setLayoutData(gridData1);
	}

	/**
	 * This method initializes compositeUntenRechts
	 * 
	 */
	private void createCompositeUntenRechts()
	{
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.END;
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		RowLayout rowLayout = new RowLayout();
		rowLayout.pack = false;
		compositeUntenRechts = new Composite(compositeUnten, SWT.NONE);
		compositeUntenRechts.setLayout(rowLayout);
		compositeUntenRechts.setLayoutData(gridData2);
		buttonUrlasser = new Button(compositeUntenRechts, SWT.NONE);
		buttonUrlasser.setText("Urlasser-Dialog ffnen");
		buttonUrlasser.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionUrlasserDialogOeffnen();
			}			
		});
		
		schaltflaecheOk = new Button(compositeUntenRechts, SWT.NONE);
		schaltflaecheOk.setText("OK");
		schaltflaecheOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOk();
			}			
		});
	}

	protected void aktionUrlasserDialogOeffnen()
	{
		/*
		 * UrlasserDialog urlasser = new UrlasserDialog(Display.getCurrent()
		 * .getActiveShell()); boolean ok = urlasser.anzeigen();
		 */
		System.out.println("ffne Urlasserdialog");
		UrlasserDialog uld = new UrlasserDialog(PlatformUI.getWorkbench()
				.getDisplay().getActiveShell());
		boolean anzeigen = (uld.anzeigen(null)).getEingabeOk();

		System.out.println("ENDE " + anzeigen);

	}

	protected void aktionOk()
	{
		setDaVAdresse(DaVVerbindung.getInstanz().getDaVIp());
		setDaVPort("" + DaVVerbindung.getInstanz().getDaVPort());
	}

	/**
	 * Setzt den Text des Feldes DaV-Adresse.
	 * 
	 * @param adresse
	 *          Zu setzender Text
	 */
	private void setDaVAdresse(String adresse)
	{
		if (adresse != null)
		{

			textDaVAdresse.setText(adresse);
		}
	}

	/**
	 * Setzt den Text des Feldes DaV-Port.
	 * 
	 * @param port
	 *          Zu setzender Text
	 */
	private void setDaVPort(String port)
	{
		if (port != null)
		{
			textDaVPort.setText(port);
		}
	}

	/**
	 * Startet den Thread
	 */
	public void startThread()
	{
		if (!_laufeThread)
		{
			Thread th = new Thread(this);
			th.setName("Verbindungsdaten auslesen");
			_laufeThread = true;
			th.start();
		}
	}

	/**
	 * Stoppt den Thread
	 */
	public void stopThread()
	{
		if (_laufeThread)
		{
			_laufeThread = false;
		}
	}

	@Override
	public void run()
	{
		while (_laufeThread)
		{
			try
			{

				Display.getDefault().asyncExec(new Runnable()
				{
					@Override
					public void run()
					{
						setDaVAdresse(DaVVerbindung.getInstanz().getDaVIp());
						setDaVPort("" + DaVVerbindung.getInstanz().getDaVPort());
					}

				});

				Thread.sleep(1000);
			} catch (InterruptedException e)
			{
				e.printStackTrace();
			}
		}
	}

} // @jve:decl-index=0:visual-constraint="13,14,465,204"
