package de.bsvrz.buv.plugin.sim;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;

import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.sim.Simulation.SimulationsArt;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit.Eingabetyp;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.SenderRole;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.AttributeGroupUsage;
import de.bsvrz.dav.daf.main.config.ConfigurationArea;
import de.bsvrz.dav.daf.main.config.ConfigurationAuthority;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.ObjectSet;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectInfo;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * ber den Definitionsdialog muss eine Simulation neu angelegt bzw. ein existierende Simulation gendert werden knnen.
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-10</li>
 * <li>TAnf-Vi-BW-C3-11</li>
 * </ul>
 * 
 * @version $Revision: 1.3 $ / $Date: 2010/02/04 06:03:56 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class SimulationDefinitionsdialog extends Dialog implements ISimulationListener
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * FilterSpeicher.
   */
  private Simulation _eintrag = null;

  // private EditorRegulaererAusdruck _editorRegulaererAusdruck = null;
  private Shell shell = null; // @jve:decl-index=0:visual-constraint="96,108"

  private Composite composite = null;

  private Label labelName = null;

  private Text textName = null;

  private Group groupFilterDefinitionen = null;

  private Composite compositeBottom = null;

  private Button buttonOk = null;

  private Button buttonAbbrechen = null;

  private Button buttonHilfe = null;

  // private Button buttonNeu1 = null;

  // private Button buttonBearbeiten1 = null;

  private Group groupZeitspezifikation = null;

  private Composite compositeZeitBereich = null;

  private Label label4 = null;
  private Label label5 = null;

  private DatumZeit zeitVon = null;
  private DatumZeit zeitBis = null;
  
//  private Text textAnfangDatum = null;
//
//  private Text textAnfangZeit = null;


//  private Text textEndDatum = null;
//
//  private Text textEndZeit = null;

  private DaVKommunikation _daVKommunikation;

  private Label labelTyp = null;

  private Combo combo2 = null;

  private ComboViewer comboViewer2 = null;

  private Composite composite1 = null;

  private Composite compositeFilterDef = null;

  private Button radioButton1 = null;

  private Label label1 = null;

  private Button radioButton2 = null;

  private Label label2 = null;

  private String _name = null;

  private SystemObject _simulationsStrecke = null;

  private Long _zeitBereichAnfang = null;

  private Long _zeitBereichEnde = null;

  /**
   * Konstruktor fr eine neue Instanz der Klasse {@link SimulationDefinitionsdialog}
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public SimulationDefinitionsdialog(Shell parent)
  {
    super(parent);
    _daVKommunikation = DaVKommunikation.getInstanz();
    _daVKommunikation.hinzufuegenSimulationListener(this);
    _eintrag = new Simulation("");

  }

  /**
   * ffnet den Dialog {@link SimulationDefinitionsdialog} zum Anlegen eines neuen Filters fr Betriebsmeldungen.
   * 
   * @return Liefert den erzeugten Filter als Instanz der Klasse {@link Filter}.
   */
  public Simulation oeffne()
  {
    // _bearbeiten = false;

    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Simulation");
    shell.setLayout(new GridLayout());

    createComposite();
    createFilterdefintion();
    createGroupZeitspezifikation();
    createCompositeBottom();

    shell.setSize(new Point(391, 310));

    _eintrag.setGewaehlteSimulationsArt(SimulationsArt.Online);
    radioButton1.setSelection(true);

    shell.open();

    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _eintrag;
  }

  /**
   * ffnet den Dialog {@link SimulationDefinitionsdialog} zum Bearbeiten eines bereits erzeugten Filters fr
   * Betriebsmeldungen.
   * 
   * @param betriebsMvDefinitionsdialogFilter
   *          Filter von Betriebsmeldungen, der bearbeitet werden soll.
   * @return Liefert <code>true</code>, falls der Filter bearbeitet wurde, sonst <code>false</code>. Wenn
   *         <code>true</code> geliefert wird, kann der Verwaltungsdialog Filter Betriebsmeldungen ({@link ZustandVerwaltungsdialog})
   *         die Darstellung der Liste der Filter aktualisieren.
   */
  public Simulation oeffne(Simulation eintrag)
  {
    _eintrag = eintrag;

    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Simulation");
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createGroupZeitspezifikation();
    createCompositeBottom();
    //shell.setSize(new Point(391, 287));
    shell.setSize(new Point(391, 310));
    textName.setText(_eintrag.getName());

    if (_eintrag.getGewaehlteSimulationsArt().equals(Simulation.SimulationsArt.Online))
    {

//      textAnfangDatum.setEnabled(false);
//      textAnfangZeit.setEnabled(false);
//      textEndDatum.setEnabled(false);
//      textEndZeit.setEnabled(false);

      zeitVon.setEnabled(false);
      zeitBis.setEnabled(false);
      
      radioButton1.setSelection(true);

    }
    else if (_eintrag.getGewaehlteSimulationsArt().equals(Simulation.SimulationsArt.Offline))
    {

//      textAnfangDatum.setEnabled(true);
//      textAnfangZeit.setEnabled(true);
//      textEndDatum.setEnabled(true);
//      textEndZeit.setEnabled(true);
      zeitVon.setEnabled(true);
      zeitBis.setEnabled(true);

      radioButton2.setSelection(true);

      
      Date d1 = new Date();
      Date d2 = new Date();
      
      d1.setTime(_eintrag.getSimulationsstart());
      d2.setTime(_eintrag.getSimulationsende());
      
      zeitVon.setDatum(d1);
      zeitBis.setDatum(d2);

//      SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm");
//      Date date = new Date();
//      date.setTime(_eintrag.getSimulationsstart());
//      String format = sdf.format(date);
//      String[] split = format.split(" ");
//      textAnfangDatum.setText(split[0]);
//      textAnfangZeit.setText(split[1]);
//
//      date.setTime(_eintrag.getSimulationsende());
//      format = sdf.format(date);
//      split = format.split(" ");
//      textEndDatum.setText(split[0]);
//      textEndZeit.setText(split[1]);

    }

    radioButton1.setEnabled(false);
    radioButton2.setEnabled(false);

    shell.open();

    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _eintrag;
  }

  /**
   * bernimmt die aktuellen Einstellungen. Dabei wird geprft,
   * <ul>
   * <li>ob eine Filterdefinition eingegeben wurde</li>
   * <li>dass ein Name eingegeben wurde</li>
   * </ul>
   * 
   */
  private void aktionOk()
  {

    String text = null;
    if (textName != null && textName.getText().length() > 0) 
    {
      text = textName.getText();      
      
      List<Simulation> simulationen = _daVKommunikation.getSimulationen();      
      
      for (Simulation s : simulationen)
      {
        if (text.equals(s.getName())){
          MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
          mb.setText("Fehler Definition");
          mb.setMessage("Simulation schon vorhanden: " + s.getName());
          mb.open();
          return;
        }
      }
      
    }else
    {      
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
      mb.setText("Fehler Definition");
      mb.setMessage("Es muss ein Name angegegben werden");
      mb.open();
      return;
    }
      
      
    if (_simulationsStrecke != null){
      
    }else
    {      
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
      mb.setText("Fehler Definition");
      mb.setMessage("Es muss eine Simulationsstrecke angegegben werden");
      mb.open();
      return;
    }
 
    Simulation simulation = new Simulation(text);

    simulation.setSimulationsStrecke(_simulationsStrecke);
    simulation.setGewaehlteSimulationsArt(_eintrag.getGewaehlteSimulationsArt());

    DataModel dataModel = _daVKommunikation.holeDaVVerbindung().getDataModel();

    AttributeGroup atg = dataModel.getAttributeGroup("atg.simulationVerwaltungAnfrage");
    Aspect asp = dataModel.getAspect("asp.anfrage");
    Data data = _daVKommunikation.holeDaVVerbindung().createData(atg);

    SystemObject so = (SystemObject)_daVKommunikation.holeDaVVerbindung().getLocalApplicationObject();

    data.getItem("AbsenderId").asReferenceValue().setSystemObject(so);
    data.getItem("AbsenderZeichen").asTextValue().setText(PlatformUI.PLUGIN_ID);

    Array array = data.getItem("ErzeugeSimulationAnfrage").asArray();
    array.setLength(1);
    array.getItem(0).getItem("Name").asTextValue().setText(textName.getText());
    array.getItem(0).getItem("ReferenzSimulationsStrecke").asReferenceValue().setSystemObject(_simulationsStrecke);

    array.getItem(0).getItem("SimulationsArt").asTextValue().setText(
        simulation.getGewaehlteSimulationsArt().toString());

    if (simulation.getGewaehlteSimulationsArt().equals(Simulation.SimulationsArt.Offline))
    {

      SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm");
      
      _zeitBereichAnfang = zeitVon.getDatum().getTime();
      _zeitBereichEnde = zeitBis.getDatum().getTime();
      
      long now = new Date().getTime();
      
      
      if (_zeitBereichAnfang > 0 && 
          _zeitBereichEnde > 0 && 
          _zeitBereichEnde > _zeitBereichAnfang && 
          _zeitBereichEnde < now){

        simulation.setSimulationsstart(_zeitBereichAnfang);
        simulation.setSimulationsende(_zeitBereichEnde);

        Array array2 = array.getItem(0).getItem("OfflineSimulationsZeitbereich").asArray();
        array2.setLength(1);
        array2.getItem(0).getItem("SimulationsBeginn").asTimeValue().setMillis(_zeitBereichAnfang);
        array2.getItem(0).getItem("SimulationsEnde").asTimeValue().setMillis(_zeitBereichEnde);

        Sender sender = new Sender(_daVKommunikation.holeDaVVerbindung());
        sender.sende(_daVKommunikation.holeDaVVerbindung().getLocalConfigurationAuthority(), atg, asp, data,
            SenderRole.sender());

        _eintrag = simulation;

        shell.dispose();
      
      }else{
        MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
        mb.setText("Fehler Definition");
        mb.setMessage("Zeitbereich ist ungltig");
        mb.open();
        return;
      }
    }
    else if (simulation.getGewaehlteSimulationsArt().equals(Simulation.SimulationsArt.Online))
    {

      Sender sender = new Sender(_daVKommunikation.holeDaVVerbindung());
      sender.sende(_daVKommunikation.holeDaVVerbindung().getLocalConfigurationAuthority(), atg, asp, data, SenderRole
          .sender());

      _eintrag = simulation;

      shell.dispose();
    }

  }

  /**
   * Schliet den Dialog {@link SimulationDefinitionsdialog} ohne bernahme der Einstellungen.
   * 
   */
  private void aktionAbbrechen()
  {
    _eintrag = null;
    shell.dispose();
  }

  /**
   * Zeigt die Hilfe zum Dialog {@link SimulationDefinitionsdialog} an.
   * 
   */
  private void aktionHilfe()
  {
    String contextId = Aktivator.PLUGIN_ID + ".simulation";
    _debug.fine("ContextID: " + contextId);
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  /**
   * This method initializes composite
   * 
   */
  private void createComposite()
  {
    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.FILL;
    gridData21.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.FILL;
    gridData11.grabExcessHorizontalSpace = true;
    gridData11.verticalSpan = 3;
    gridData11.verticalAlignment = GridData.FILL;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    composite = new Composite(shell, SWT.NONE);
    composite.setLayoutData(gridData);
    composite.setLayout(gridLayout);
    labelName = new Label(composite, SWT.NONE);
    labelName.setText("Name");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData1);
    textName.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _name = textName.getText();

      }
    });

    labelTyp = new Label(composite, SWT.NONE);
    labelTyp.setText("SimulationsStrecke");
    combo2 = new Combo(composite, SWT.BORDER | SWT.READ_ONLY);
    combo2.setLayoutData(gridData21);
    combo2.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        IStructuredSelection structuredSelection = (IStructuredSelection)comboViewer2.getSelection();

        Object obj = structuredSelection.getFirstElement();

        if (obj instanceof SystemObject)
        {
          _simulationsStrecke = (SystemObject)obj;

        }

      }
    });

    comboViewer2 = new ComboViewer(combo2);
    comboViewer2.setLabelProvider(new ILabelProvider() {
      @Override
      public Image getImage(Object element)
      {
        return null;
      }

      @Override
      public String getText(Object element)
      {
        String returnString = null;

        if (element instanceof SystemObject)
        {
          returnString = ((SystemObject)element).getName();
        }
        else if (element instanceof DummySystemObject)
        {

          returnString = ((DummySystemObject)element).getName();

        }
        return returnString;
      }

      @Override
      public void addListener(ILabelProviderListener listener)
      {

      }

      @Override
      public void dispose()
      {

      }

      @Override
      public boolean isLabelProperty(Object element, String property)
      {
        return false;
      }

      @Override
      public void removeListener(ILabelProviderListener listener)
      {
      }

    });
    List<SystemObject> list = holeSimulationsStrecken();
    for (SystemObject so : list)
    {
      comboViewer2.add(so);
    }
  }

  /**
   * This method initializes Filterdefintion
   * 
   */
  private void createFilterdefintion()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessVerticalSpace = false;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    groupFilterDefinitionen = new Group(shell, SWT.NONE);
    groupFilterDefinitionen.setLayout(new GridLayout());
    groupFilterDefinitionen.setLayoutData(gridData2);
    createComposite1();
    groupFilterDefinitionen.setText("Art der Simulation");
  }

  /**
   * This method initializes compositeBottom
   * 
   */
  private void createCompositeBottom()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(shell, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");
    buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOk();
			}			
		});

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionAbbrechen();
			}			
		});
    
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");
    buttonHilfe.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionHilfe();
			}			
		});
  }

  /**
   * This method initializes groupZeitspezifikation
   * 
   */
  private void createGroupZeitspezifikation()
  {
    GridLayout gridLayout4 = new GridLayout();
    gridLayout4.numColumns = 13;
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessVerticalSpace = false;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.verticalAlignment = GridData.CENTER;
    groupZeitspezifikation = new Group(shell, SWT.NONE);

    createCompositeZeitBereich();

    groupZeitspezifikation.setLayoutData(gridData4);
    Label filler4 = new Label(groupZeitspezifikation, SWT.NONE);
    groupZeitspezifikation.setLayout(gridLayout4);
    groupZeitspezifikation.setText("Zeitspezifikation");
    groupZeitspezifikation.layout();
  }

  /**
   * This method initializes compositeZeitSpec
   * 
   */
  private void createCompositeZeitBereich()
  {
    GridData gridData15 = new GridData();
    gridData15.horizontalSpan = 2;
    GridData gridData14 = new GridData();
    gridData14.horizontalAlignment = GridData.CENTER;
    gridData14.grabExcessHorizontalSpace = false;
    gridData14.verticalAlignment = GridData.CENTER;
    GridData gridData13 = new GridData();
    gridData13.horizontalSpan = 12;
    gridData13.horizontalAlignment = GridData.BEGINNING;
    gridData13.verticalAlignment = GridData.CENTER;
    gridData13.grabExcessHorizontalSpace = false;
    GridData gridData10 = new GridData();
    gridData10.horizontalAlignment = GridData.BEGINNING;
    gridData10.grabExcessHorizontalSpace = false;
    gridData10.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.BEGINNING;
    gridData11.grabExcessHorizontalSpace = false;
    gridData11.verticalAlignment = GridData.CENTER;  
    GridLayout gridLayout2 = new GridLayout();
    gridLayout2.numColumns = 2;
    compositeZeitBereich = new Composite(groupZeitspezifikation, SWT.NONE);
    compositeZeitBereich.setLayout(gridLayout2);
    compositeZeitBereich.setLayoutData(gridData13);
    
    label4 = new Label(compositeZeitBereich, SWT.NONE);
    label4.setText("Simulationsstart");
    zeitVon = new DatumZeit(compositeZeitBereich, SWT.NONE, Eingabetyp.datumuhrEinfach, false, false);
    zeitVon.setLayoutData(gridData10);
    label5 = new Label(compositeZeitBereich, SWT.NONE);
    label5.setText("Simulationsende");
    zeitBis = new DatumZeit(compositeZeitBereich, SWT.NONE, Eingabetyp.datumuhrEinfach, false, false);
    zeitBis.setLayoutData(gridData11);
    zeitVon.setEnabled(false);
    zeitBis.setEnabled(false);
    
//    textAnfangDatum = new Text(compositeZeitBereich, SWT.BORDER);
//    textAnfangDatum.setLayoutData(gridData15);
//    textAnfangZeit = new Text(compositeZeitBereich, SWT.BORDER);
//    textAnfangZeit.setLayoutData(gridData10);
//    textEndDatum = new Text(compositeZeitBereich, SWT.BORDER);
//    Label filler1 = new Label(compositeZeitBereich, SWT.NONE);
//    textEndZeit = new Text(compositeZeitBereich, SWT.BORDER);
//    textEndZeit.setLayoutData(gridData14);
//    textAnfangDatum.setEnabled(false);
//    textAnfangZeit.setEnabled(false);
//    textEndDatum.setEnabled(false);
//    textEndZeit.setEnabled(false);
  }

  /**
   * This method initializes composite1
   * 
   */
  private void createComposite1()
  {
    composite1 = new Composite(groupFilterDefinitionen, SWT.NONE);
    composite1.setLayout(new FillLayout());
    createCompositeFilterDef2();
  }

  /**
   * This method initializes compositeFilterDef
   * 
   */
  private void createCompositeFilterDef2()
  {
    GridData gridData101 = new GridData();
    gridData101.horizontalAlignment = GridData.CENTER;
    gridData101.grabExcessHorizontalSpace = false;
    gridData101.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout1 = new GridLayout();
    gridLayout1.numColumns = 2;
    gridLayout1.marginHeight = 5;
    gridLayout1.marginWidth = 5;
    gridLayout1.verticalSpacing = 5;
    compositeFilterDef = new Composite(composite1, SWT.NONE);
    compositeFilterDef.setLayout(gridLayout1);
    label1 = new Label(compositeFilterDef, SWT.NONE);
    label1.setText("Online Simulation");
    radioButton1 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton1.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton1.getSelection())
        {
          _eintrag.setGewaehlteSimulationsArt(Simulation.SimulationsArt.Online);
          zeitVon.setEnabled(false);
          zeitBis.setEnabled(false);
//          textAnfangDatum.setEnabled(false);
//          textAnfangZeit.setEnabled(false);
//          textEndDatum.setEnabled(false);
//          textEndZeit.setEnabled(false);
        }

      }

    });
    label2 = new Label(compositeFilterDef, SWT.NONE);
    label2.setText("Offline Simulation");
    radioButton2 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton2.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton2.getSelection())
        {
          _eintrag.setGewaehlteSimulationsArt(Simulation.SimulationsArt.Offline);
          zeitVon.setEnabled(true);
          zeitBis.setEnabled(true);
//          textAnfangDatum.setEnabled(true);
//          textAnfangZeit.setEnabled(true);
//          textEndDatum.setEnabled(true);
//          textEndZeit.setEnabled(true);
        }

      }

    });
  }

  private List<SystemObject> holeSimulationsStrecken()
  {

    ConfigurationAuthority konfigurationsObjekt = DaVKommunikation.getInstanz().holeDaVVerbindung()
        .getLocalConfigurationAuthority();

    ObjectSet objekte = konfigurationsObjekt.getObjectSet("SimulationsStrecken");

    List<SystemObject> list = objekte.getElements();

    List<SystemObject> listTmp = new ArrayList<SystemObject>();
    for (SystemObject systemObject : list)
    {
      if (!systemObject.isValid())
      {

        listTmp.add(systemObject);
      }
    }
    // list.removeAll(listTmp);

    return list;

  }

  private class DummySystemObject implements SystemObject
  {

    private String _name = null;

    public DummySystemObject()
    {
      _name = "undefiniert";
    }

    @Override
    public ConfigurationArea getConfigurationArea()
    {
      return null;
    }

    @Override
    public Data getConfigurationData(AttributeGroup atg)
    {
      return null;
    }

    @Override
    public Data getConfigurationData(AttributeGroupUsage atgUsage)
    {
      return null;
    }

    @Override
    public Data getConfigurationData(AttributeGroup atg, Aspect asp)
    {
      return null;
    }

    @Override
    public DataModel getDataModel()
    {
      return null;
    }

    @Override
    public long getId()
    {
      return 0;
    }

    @Override
    public SystemObjectInfo getInfo()
    {
      return null;
    }

    @Override
    public String getName()
    {
      return _name;
    }

    @Override
    public String getNameOrPidOrId()
    {
      return null;
    }

    @Override
    public String getPid()
    {
      return null;
    }

    @Override
    public String getPidOrId()
    {
      return null;
    }

    @Override
    public String getPidOrNameOrId()
    {
      return null;
    }

    @Override
    public SystemObjectType getType()
    {
      return null;
    }

    @Override
    public Collection<AttributeGroupUsage> getUsedAttributeGroupUsages()
    {
      return null;
    }

    @Override
    public void invalidate() throws ConfigurationChangeException
    {
    }

    @Override
    public boolean isOfType(SystemObjectType type)
    {
      return false;
    }

    @Override
    public boolean isOfType(String typePid)
    {
      return false;
    }

    @Override
    public boolean isValid()
    {
      return false;
    }

    @Override
    public void setConfigurationData(AttributeGroup atg, Data data) throws ConfigurationChangeException
    {
    }

    @Override
    public void setConfigurationData(AttributeGroupUsage atgUsage, Data data) throws ConfigurationChangeException
    {
    }

    @Override
    public void setConfigurationData(AttributeGroup atg, Aspect asp, Data data) throws ConfigurationChangeException
    {
    }

    @Override
    public void setName(String name) throws ConfigurationChangeException
    {
    }

    @Override
    public int compareTo(Object o)
    {
      return 0;
    }

  }

  @Override
  public void simulationEingang(SimulationEreignis e)
  {
    for (Simulation s : e.getSimulationen())
    {
      if (_eintrag != null && s.getPid().equals(_eintrag.getPid()))
      {
        _eintrag = s;
        break;
      }
    }

  }

}
