/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.einstellungen;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.PathEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.rw.basislib.Activator;

public class EinstellungenPraeferenzSeite extends FieldEditorPreferencePage
		implements IWorkbenchPreferencePage
{
	// Die Workbench-Instanz
	@SuppressWarnings("unused")
	private IWorkbench workbench;

	public EinstellungenPraeferenzSeite()
	{
		super(org.eclipse.jface.preference.FieldEditorPreferencePage.GRID);
		// setPreferenceStore(Activator.getDefault().getPreferenceStore());
		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("Hier werden die Pfade zum Verzeichnis der Einstellungen gesetzt.");
	}

	public void init(IWorkbench workbench)
	{
		this.workbench = workbench;

	}

	/**
	 * Seiteninhalt aufbauen
	 */
	public void createControl(Composite parent)
	{
		super.createControl(parent);
		// workbench.getHelpSystem().setHelp(getControl(),
		// getPreferenceHelpContextID());
	}

	@Override
	protected void createFieldEditors()
	{

		Composite composite = getFieldEditorParent();

		addField(new PathEditor(EinstellungenBezeichner.psPfadEinstellungen,
				"Pfad zu den Einstellungsdateien:",
				"Pfad zur Speicherung von Voreinstellungsdateien whlen", composite));
	}

	public void performHelp()
	{
		String helpContextId = Activator.PLUGIN_ID + ".voreinstellungen";
		PlatformUI.getWorkbench().getHelpSystem().displayHelp(helpContextId);
	}

}
