/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.mehrfachzwischenablage;

import java.util.Iterator;
import java.util.LinkedList;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.sys.funclib.debug.Debug;

/**
 * Implementiert den Handler, der fr das Einfgen verantwortlich ist.
 * 
 * @author HofmannJ
 * 
 */
public class RoutineKommandoEinfuegen extends AbstractHandler
{

	/**
	 * Der Debugger
	 */
	private Debug _debug = Debug.getLogger();

	private MehrfachZwischenablageDaten _zwischenablageDaten;

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException
	{
		_zwischenablageDaten = MehrfachZwischenablageDaten.getInstanz();
		_debug.fine("Einfgen");

		IWorkbenchPart activePart = PlatformUI.getWorkbench()
				.getActiveWorkbenchWindow().getActivePage().getActivePart();

		if (activePart instanceof IMehrfachZwischenablageEinfuegen)
		{
			IMehrfachZwischenablageEinfuegen ein = (IMehrfachZwischenablageEinfuegen) activePart;
			_debug.fine(getClass().getName()
					+ "::execute \n\t=> NAME DER KLASSE: "
					+ _zwischenablageDaten.getSelektionMehrfachZwischenablageIntern()
							.getClass().getName());

			_debug.fine(_zwischenablageDaten
					.getSelektionMehrfachZwischenablageIntern().toString());

			Iterator<ZwischenablageDatensatz> it = _zwischenablageDaten
					.getSelektionMehrfachZwischenablageIntern().iterator();
			LinkedList<Object> tempListe = new LinkedList<Object>();
			while (it.hasNext())
			{
				ZwischenablageDatensatz zwischenablageDatensatz = it.next();
				tempListe.add(zwischenablageDatensatz.getWert());
				zwischenablageDatensatz.setBereitsEingefuegt(true); // Als bereits
																														// eingefgt
																														// markieren
				_zwischenablageDaten
						.benachrichtigeZuhoererAusschneiden(zwischenablageDatensatz);
			}

			ein.einfuegen(tempListe);

		} else
		{
			_debug
					.fine(getClass().getName()
							+ "::execute \n\t=> Der aktuell aktive Part implementiert nicht das Interface IMehrfachZwischenablageEinfuegen. Es ist somit nicht mglich, ein Objekt aus der MehrfachZwischenablage einzufgen.");
		}

		return null;
	}

}
