/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.editoren;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

/**
 * Diese Klasse stellt ein Perspektive zum Bearbeiten des Hauptmens bereit. Auf der rechten Seite findet sich die
 * aktuelle Darstellung des Hauptmens, auf der linken Seite befinden sich die einsetzbaren globalen Actions.
 * 
 * @author HofmannJ
 * 
 */
public class PerspektiveMenuEditor implements IPerspectiveFactory
{
  /*
   * Ein Aufruf dieser Perspektive kann sich wie folgt darstellen: IPerspectiveDescriptor perspectiveDescriptor =
   * PlatformUI.getWorkbench().getPerspectiveRegistry().findPerspectiveWithId("de.bsvrz.buv.rw.basislib.perspectiveHauptMenuEditor");
   * PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().setPerspective(perspectiveDescriptor);
   */

  private String _idSichtRegistrierteOberflaechenElemente = "de.bsvrz.buv.rw.basislib.viewMenuEditorXmlElemente";

  private String _idSichtRegistrierteOberflaechenAktionen = "de.bsvrz.buv.rw.basislib.viewMenuEditorXmlActions";

  private String _idSichtRegistrierteOberflaechenAktionenGlobal = "de.bsvrz.buv.rw.basislib.viewMenuEditorXmlActionsGlobal";

  public PerspektiveMenuEditor()
  {
  }

  public void createInitialLayout(IPageLayout layout)
  {
    layout.setFixed(false);
    layout.setEditorAreaVisible(true);
    String editorId = layout.getEditorArea();

    // Auf der linken Seite erfolgt die Darstellung der vefgbaren Elemente
    IFolderLayout obenLinks = layout.createFolder("links", IPageLayout.LEFT, 0.35f, editorId);
    obenLinks.addView(_idSichtRegistrierteOberflaechenElemente);
    obenLinks.addView(_idSichtRegistrierteOberflaechenAktionen);
    obenLinks.addView(_idSichtRegistrierteOberflaechenAktionenGlobal);

    // Auf der rechten Seite erfolgt die Darstellung der aktuellen Menstruktrur
    // IFolderLayout obenRechts = layout.createFolder("rechtsoben",
    // IPageLayout.RIGHT, 0.65f, editorId);
    // obenRechts.addView(_idSichtXmlBaum);

    // Unten
    // IFolderLayout bottomRight = layout.createFolder("rechtsunten", IPageLayout.BOTTOM, 0.5f, IPageLayout.ID_OUTLINE);
    // bottomRight.addView("de.bsvrz.buv.rw.basislib.alt.menuViewEditPart.views.ViewCoolBarEditor");

  }

}
