/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.editoren;

import org.jdom.Element;

/**
 * Speichert das XML-Element, das aktuell via Drag & Drop an eine andere
 * Position verschoben werden soll.
 * 
 * @author HofmannJ
 * 
 */
public class ZugElementSpeicher
{

	private Element _zugElement = null;

	// private static ZugElementSpeicher _instanz = null;
	// public static ZugElementSpeicher getInstanz()
	// {
	// if (_instanz == null)
	// {
	// _instanz = new ZugElementSpeicher();
	// }
	// return _instanz;
	// }

	/**
	 * Privater Konstruktor
	 */
	private ZugElementSpeicher()
	{
	}

	/**
	 * Speichert die Singleton-Instanz der Klasse {@link ZugElementSpeicher}.
	 * 
	 * @author HofmannJ
	 * 
	 */
	private static class Innen
	{
		private static ZugElementSpeicher INSTANZ = new ZugElementSpeicher();
	}

	/**
	 * Liefert die Singleton-Instanz der Klasse {@link ZugElementSpeicher}.
	 * 
	 * @return Singleton-Instanz der Klasse {@link ZugElementSpeicher}.
	 */
	public static ZugElementSpeicher getInstanz()
	{
		return Innen.INSTANZ;
	}

	/**
	 * Liefert das Drag-Element
	 * 
	 * @return Drag-Element
	 */
	public Element getZugElement()
	{
		return _zugElement;
	}

	/**
	 * Setzt das Drag-Element
	 * 
	 * @param dragElement
	 */
	public void setZugElement(Element dragElement)
	{
		this._zugElement = dragElement;
	}

	/**
	 * Setzt den Speicher zurck.
	 * 
	 */
	public void zuruecksetzen()
	{
		this._zugElement = null;
	}

}
