/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.ort.hilfsklassen;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;
import java.util.Map.Entry;

import de.bsvrz.buv.rw.basislib.ort.hilfsklassen.StrassenTeilSegment.BetriebsKilometerEintrag;
import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.CommunicationError;
import de.bsvrz.dav.daf.main.ConnectionException;
import de.bsvrz.dav.daf.main.InconsistentLoginException;
import de.bsvrz.dav.daf.main.MissingParameterException;

public class TestAlt
{
  /**
   * Debug-Flag
   */
  private static final boolean _debug = false;

  /**
   * Verbindung zum DaV
   */
  private ClientDavConnection _verbindung = null;

  private static final String _ip = "192.0.1.117";

  private static final int _port = 8083;

  private static final String _benutzer = "Tester";

  private static final String _passwort = "geheim";

  private KonfigurationNeu _konf = null;

  /**
   * @param args
   */
  public static void main(String[] args)
  {
    System.out.println("START:");
    TestAlt te = new TestAlt();
    // te.testKonfiguration();
    // te.testSst();
    // te.test3();
    te.test4();
    te.schliesseDaVVerbindung();
  }

  public void testKonfiguration()
  {
    if (_verbindung != null)
    {
      KonfigurationNeu konf = KonfigurationNeu.getInstanz();
      konf.bestimmeObjekte(_verbindung);
      konf.filtereNachStrasse("strasse.A.3.tmclc.07077");
      // konf.filtereNachStrasse("strasse.A.45.tmclc.07115");

      System.out.println("=>\n" + konf.toString());

      Iterator<Entry<String, AeusseresStrassenSegment>> itAussen = konf.getAeussereStrassenSegmente().entrySet()
          .iterator();
      while (itAussen.hasNext())
      {
        Entry<String, AeusseresStrassenSegment> entry = itAussen.next();

        if (true)
        // if(entry.getValue().getVonKnoten() == null)
        {
          String aussen = entry.getValue().toString();
          // System.out.println("==> ueres Straensegment:\n" + aussen +
          // "\n");
          AeusseresStrassenSegment aeusseresStrassenSegment = entry.getValue();

          int anz = aeusseresStrassenSegment.getNachfolgerAufStrasse().size();

          if (anz > 0)
          {
            System.out.println("=====> ueres Straensegment:\n" + aussen);

            String richtungStrasse = aeusseresStrassenSegment.getRichtungStrasse();

            System.out.println("===> Anzahl der Nachfolger: " + anz + "\n\n\n");

            Iterator<StrassenSegment> itNfInKnoten = aeusseresStrassenSegment.getNachfolgerAufStrasse().iterator();
            while (itNfInKnoten.hasNext())
            {
              StrassenSegment tmp = itNfInKnoten.next();
              if (tmp instanceof InneresStrassenSegment)
              {
                InneresStrassenSegment innen = (InneresStrassenSegment)tmp;
                // System.out.println("NF::::\n" + innen.toString());

                Iterator<StrassenSegment> itNfInnen = innen.getNachfolgerAufStrasse().iterator();
                while (itNfInnen.hasNext())
                {
                  StrassenSegment ss = itNfInnen.next();
                  if (ss instanceof AeusseresStrassenSegment)
                  {
                    AeusseresStrassenSegment aSegment = (AeusseresStrassenSegment)ss;
                    if (!aSegment.getRichtungStrasse().equals(richtungStrasse))
                    {
                      System.err.println("FALSCHE RICHTUNG!!!");
                    }
                    else
                    {
                      System.out.println("NFIN:::::>\n" + aSegment.toString());
                    }

                  }

                }
              }
            }

          }
          else
          {
            // System.out.println("Anzahl der Nachfolger: " + anz);
          }

          // Iterator<StrassenSegment> itnf =
          // aeusseresStrassenSegment.getNachfolgerAufStrasse().iterator();
          // while(itnf.hasNext())
          // {
          // StrassenSegment strassenSegment = itnf.next();
          // System.out.println("Nachfolger: " + strassenSegment.toString());
          // System.out.println("L: " +
          // strassenSegment.getNachfolgerAufStrasse().size());
          //						
          // if(strassenSegment instanceof InneresStrassenSegment)
          // {
          // InneresStrassenSegment inneresStrassenSegment =
          // (InneresStrassenSegment) strassenSegment;
          // System.err.println("Nachfolger d. Nachfolgers: " +
          // inneresStrassenSegment.getNachfolgerAufStrasse().size());
          // }
          // }

        }
      }

      // Iterator<Entry<String, InneresStrassenSegment>> itInnen =
      // konf.getInnereStrassenSegmente().entrySet().iterator();
      // while(itInnen.hasNext())
      // {
      // Entry<String, InneresStrassenSegment> entry = itInnen.next();
      //				
      // if(entry.getValue().getVonStrassenSegmemt() == null)
      // {
      // System.out.println("NULL");
      // String innen = entry.getValue().toString();
      // System.out.println("Inneres Strassensegment:\n" + innen + "\n");
      // }
      // }

      // Iterator<Entry<String, StrassenKnoten>> it =
      // konf.getStrassenKnoten().entrySet().iterator();
      // while(it.hasNext())
      // {
      // Entry<String, StrassenKnoten> entry = it.next();
      // System.out.println("Knoten:\n" + entry.getValue().toString() + "\n");
      // }

    }
  }

  public void testSst()
  {
    _konf = KonfigurationNeu.getInstanz();
    _konf.bestimmeObjekte(_verbindung);
    // _konf.filtereNachStrasse("strasse.A.3.tmclc.07077");
    _konf.filtereNachStrasse("strasse.A.45.tmclc.07115");

    System.out.println("=>\n" + _konf.toString());

    teilsegmenteHolen();

  }

  /**
   * Vorprfung des Anfangs der Blcke innerhalb der StraenTeilSegmente
   */
  public void test3()
  {
    _konf = KonfigurationNeu.getInstanz();
    _konf.bestimmeObjekte(_verbindung);
    // _konf.filtereNachStrasse("strasse.A.3.tmclc.07077");
    _konf.filtereNachStrasse("strasse.A.45.tmclc.07115");

    System.out.println("=>\n" + _konf.toString());

    Iterator<Entry<String, AeusseresStrassenSegment>> it = _konf.getAeussereStrassenSegmenteGefiltert().entrySet()
        .iterator();
    while (it.hasNext())
    {
      Entry<String, AeusseresStrassenSegment> entry = it.next();
      AeusseresStrassenSegment aeusseresStrassenSegment = entry.getValue();
      Iterator<StrassenTeilSegment> itSts = aeusseresStrassenSegment.getStrassenTeilSegmente().iterator();
      while (itSts.hasNext())
      {
        StrassenTeilSegment strassenTeilSegment = itSts.next();
        System.out.println("\nBestimme Bereich fr StraenTeilSegment " + strassenTeilSegment.getPid() + ":");
        strassenTeilSegment.bestimmeBereiche();
      }
    }
  }

  /**
   * Aufreihen zum finden des Anfangs der Blcke
   */
  public void test4()
  {
    _konf = KonfigurationNeu.getInstanz();
    _konf.bestimmeObjekte(_verbindung);
    // _konf.filtereNachStrasse("strasse.A.3.tmclc.07077");
    _konf.filtereNachStrasse("strasse.A.45.tmclc.07115");

    System.out.println("=>\n" + _konf.toString());

    // LinkedList<AeusseresStrassenSegment> gemerkt = new LinkedList<AeusseresStrassenSegment>();
    //		
    // Iterator<Entry<String, AeusseresStrassenSegment>> itAeussen =
    // _konf.getAeussereStrassenSegmenteGefiltert().entrySet().iterator();
    // while(itAeussen.hasNext())
    // {
    //
    //			
    // Entry<String, AeusseresStrassenSegment> entry = itAeussen.next();
    // AeusseresStrassenSegment aeusseresStrassenSegment = entry.getValue();
    // StrassenKnoten vonKnoten = aeusseresStrassenSegment.getVonKnoten();
    //			
    //			
    // Iterator<AeusseresStrassenSegment> itHinz = vonKnoten.getHinfuehrendeAeussereStrassenSegmente().iterator();
    // while(itHinz.hasNext())
    // {
    // AeusseresStrassenSegment hinzAeusseresStrassenSegment = itHinz.next();
    // if(_konf.getAeussereStrassenSegmenteGefiltert().containsKey(hinzAeusseresStrassenSegment.getPid()))
    // {
    // gemerkt.add(aeusseresStrassenSegment);
    // gefunden = true;
    // }
    // }
    // }
    //		
    // System.out.println("Germerkt: " + gemerkt.size());

  }

  public void teilsegmenteHolen()
  {
    if (_konf != null)
    {

      /*
       * Iterator ber alle ueren Straensegmente
       */
      Iterator<Entry<String, AeusseresStrassenSegment>> it = _konf.getAeussereStrassenSegmenteGefiltert().entrySet()
          .iterator();
      while (it.hasNext())
      {
        System.out.println("===teilsegmenteHolen===");

        Entry<String, AeusseresStrassenSegment> entry = it.next();
        AeusseresStrassenSegment aeusseresStrassenSegment = entry.getValue();
        int size = aeusseresStrassenSegment.getStrassenTeilSegmenteAbOffset(0).size();

        System.out.println("Strassensegment: " + aeusseresStrassenSegment.getPid());
        System.out.println("Anzahl STS: " + size);

        Iterator<StrassenTeilSegment> itSts = aeusseresStrassenSegment.getStrassenTeilSegmenteAbOffset(0).iterator();
        while (itSts.hasNext())
        {
          StrassenTeilSegment sts = itSts.next();
          System.out.println("STS: " + sts.toString());
        }

        long wertNachfogler = getAnfangsWertBetriebskilometerNachfolgendesStrassenSegment(aeusseresStrassenSegment);
        System.out.println("<-Wert nachfolger: " + wertNachfogler + "->");

        System.out.println("===teilsegmenteHolen ENDE===\n");
      }
    }
  }

  /**
   * Liefert den Anfangswert des Betriebskilometers des ersten StrassenTeilSegmentes des nachfolgenden StraenSegments.
   * 
   * @param straenSegment
   *          Das Straensegment, von dessen Nachfolger der Wert des Betriebskilometers des ersten StraenTeilSegmentes
   *          bestimmt werden soll.
   * @return Ermittelter Betriebskilometer oder -1, falls keiner ermittelt werden konnte.
   */
  public long getAnfangsWertBetriebskilometerNachfolgendesStrassenSegment(StrassenSegment straenSegment)
  {
    long re = -1;

    boolean ersterWertBesorgt = false;

    if (_debug)
    {
      System.out.println("===getAnfangsBKNachfolgeStrassenSegment===");
    }

    Vector<StrassenSegment> nachfolgerAufStrasse = straenSegment.getNachfolgerAufStrasse();

    Iterator<StrassenSegment> it = nachfolgerAufStrasse.iterator();
    while (it.hasNext())
    {

      StrassenSegment nachfolgeStrassenSegment = it.next();
      Iterator<StrassenTeilSegment> itSts = nachfolgeStrassenSegment.getStrassenTeilSegmenteAbOffset(0).iterator();
      while (itSts.hasNext())
      {
        StrassenTeilSegment stsNachfolgend = itSts.next();

        if (!ersterWertBesorgt)
        {
          // re = stsNachfolgend.getBKWert();
          if (stsNachfolgend.getBetriebsKilometer().size() > 0)
          {
            re = stsNachfolgend.getBetriebsKilometer().get(0).getWert();
          }

        }

        if (_debug)
        {
          if (straenSegment instanceof AeusseresStrassenSegment)
          {
            System.out.println("STS NACHFOLGEND (AUSSEN PID: " + nachfolgeStrassenSegment.getPid() + "): "
                + stsNachfolgend.toString());

            AeusseresStrassenSegment aussen = (AeusseresStrassenSegment)straenSegment;
            System.out.println("=>RICHTUNG: " + aussen.getTmcRichtung());
          }
          else if (straenSegment instanceof InneresStrassenSegment)
          {
            System.out.println("STS NACHFOLGEND (INNEN PID: " + nachfolgeStrassenSegment.getPid() + "):  "
                + stsNachfolgend.toString());
          }
          else
          {
            System.err.println("ERROR!");
          }
        }

      }
    }

    if (_debug)
    {
      System.out.println("===getAnfangsBKNachfolgeStrassenSegment ENDE===\n");
    }

    return re;
  }

  /*
   * Prfen, ob ein BK in den SSTs eines BKs vorkommt
   */
  public void bestimmeBlockInStsEinesStrassenSegments(StrassenSegment strassenSegment, long betriebsKilometerWert)
  {
    Vector<StrassenTeilSegment> strassenTeilSegmente = strassenSegment.getStrassenTeilSegmente();

    // StraenTeilSegmente
    for (int idxSST = 0; idxSST < strassenTeilSegmente.size(); idxSST++)
    {

      StrassenTeilSegment sst = strassenTeilSegmente.get(idxSST);
      long laengeSST = sst.getLaenge();

      // BetriebsKilometer
      LinkedList<BetriebsKilometerEintrag> betriebsKilometer = sst.getBetriebsKilometer();
      for (int idxBK = 0; idxBK < betriebsKilometer.size(); idxBK++)
      {

        long wert1 = betriebsKilometer.get(idxBK).getWert();
        long wert2 = wert1;
        long restlaenge = laengeSST;

        // Suche in den BetriebsKilometern des aktuellen STS
        if ((idxBK + 1) < betriebsKilometer.size())
        {
          wert2 = betriebsKilometer.get(idxBK + 1).getWert();

          /*
           * Bestimmung der Restlnge
           */
          if (wert2 > wert1)
          {
            restlaenge = restlaenge - (wert2 - wert1);
          }
          else if (wert1 > wert2)
          {
            restlaenge = restlaenge - (wert1 - wert2);	
          }

        }
        else
        {
          // Suche in den BetriebsKilometern des nchsten STS im aktuellen
          // StrassenSegment
          if (idxSST + 1 < strassenTeilSegmente.size())
          {
            if (strassenTeilSegmente.get(idxSST + 1).getBetriebsKilometer().size() > 0)
            {
              wert2 = strassenTeilSegmente.get(idxSST + 1).getBetriebsKilometer().get(0).getWert();
            }
          }
          else
          // Suche in den Betriebkilometern des nchsten Straensegments
          {
            wert2 = getAnfangsWertBetriebskilometerNachfolgendesStrassenSegment(strassenSegment);

            // Wenn es kein nchstes Straensegment gibt, muss die lnge bis zum
            // ende bestimmt werden
          }
        }

      }
    }
  }

  public void berechneLaengeObInSts(StrassenTeilSegment sts, LinkedList<StrassenTeilSegment> lSts,
      StrassenSegment strassenSegment)
  {
    if (lSts.contains(strassenSegment))
    {
      @SuppressWarnings("unused")
			int idxStsInListe = lSts.indexOf(sts);

    }
    else
    {
      System.err.println("Das StraenSegment ist nich in der Liste der Straensegmente enthalten!");
    }
  }

  /**
   * Konstruktor
   */
  public TestAlt()
  {
    init();
  }

  /**
   * Fhrt Initialisierungen durch
   */
  private void init()
  {
    baueDaVVerbindungAuf();
  }

  /**
   * Baut die Verbindung zum DaV auf.
   */
  protected void baueDaVVerbindungAuf()
  {
    try
    {
      _verbindung = new ClientDavConnection();

      // IP setzen
      _verbindung.getClientDavParameters().setDavCommunicationAddress(_ip);

      // Port setzen
      _verbindung.getClientDavParameters().setDavCommunicationSubAddress(_port);

      try
      {
        _verbindung.connect();
        System.out.println("Verbindungsaufbau: Verbindung erfolgreich aufgebaut.");

        try
        {
          _verbindung.login(_benutzer, _passwort);
          System.out.println("Verbindungsaufbau: Benutzer erfolgreich eingeloggt.");
        }
        catch (InconsistentLoginException e)
        {
          // e.printStackTrace();
          System.err.println("Verbindungsaufbau Fehler: Konnte Benutzer nicht einloggen.");
          _verbindung = null;
        }

      }
      catch (CommunicationError e)
      {
        // e.printStackTrace();
        System.err.println("Verbindungsaufbau Fehler: " + e.toString());
        _verbindung = null;
      }
      catch (ConnectionException e)
      {
        // e.printStackTrace();
        System.err.println("Verbindungsaufbau Fehler: " + e.toString());
        _verbindung = null;
      }

    }
    catch (MissingParameterException e)
    {
      // e.printStackTrace();
      System.err.println("Verbindungsaufbau Fehler: " + e.toString());
      _verbindung = null;
    }
  }

  /**
   * Schliet die Verbindung zum DaV
   */
  public void schliesseDaVVerbindung()
  {
    if (_verbindung != null)
    {
      _verbindung.disconnect(false, "Kein Fehler.");
      System.out.println("Verbindungsabbau: Verbindung wurde abgebaut.");
    }
  }

}
