/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.statusleiste.editor;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

public class PerspektiveStatusLeisteEditor implements IPerspectiveFactory
{
  private static final String _viewVerfuegbareStatusleistenElemente = "de.bsvrz.buv.rw.basislib.viewVerfuegbareStatusleistenElemente";

  private static final String _viewEditorStatusleistenElemente = "de.bsvrz.buv.rw.basislib.viewEditorStatusLeistenelemente";

  public void createInitialLayout(IPageLayout layout)
  {
    layout.setFixed(false);
    layout.setEditorAreaVisible(false);
    String editorId = layout.getEditorArea();

    // Auf der linken Seite erfolgt die Darstellung der vefgbaren Elemente
    IFolderLayout obenLinks = layout.createFolder("links", IPageLayout.LEFT, 0.45f, editorId);
    obenLinks.addView(_viewVerfuegbareStatusleistenElemente);

    // Auf der rechten Seite erfolgt die Darstellung der aktuellen Menstruktrur
    IFolderLayout obenRechts = layout.createFolder("rechtsoben", IPageLayout.RIGHT, 0.55f, editorId);
    // obenRechts.addView("de.bsvrz.buv.rw.basislib.sichtLegende");
    obenRechts.addView(_viewEditorStatusleistenElemente);

    // Unten
    // IFolderLayout untenRechts = layout.createFolder("rechtsunten", IPageLayout.BOTTOM, 0.5f, IPageLayout.ID_OUTLINE);

  }

}
