/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.tabellen;

public class XmlFilterTest
{

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		XmlFilterVerwaltung xmlFilter = new XmlFilterVerwaltung();
		System.out.println(xmlFilter.ausgabeXmlFormatiert());

		ElementFilter elementFilter0 = new ElementFilter(xmlFilter
				.bestimmeNaechsteFreieIdElementFilter(), "sksks");
		elementFilter0.addRegEx(new ElementRegEx(elementFilter0
				.bestimmeNaechsteFreieIdRegEx(), "1.ster Ausdruck", ".*"));
		elementFilter0.addRegEx(new ElementRegEx(elementFilter0
				.bestimmeNaechsteFreieIdRegEx(), "2.ter Ausdruck", "A"));
		xmlFilter.addElementFilter(elementFilter0);

		int id2 = xmlFilter.bestimmeNaechsteFreieIdElementFilter();
		ElementFilter elementFilter1 = new ElementFilter(id2, "Zweiter Filter");
		elementFilter1.addRegEx(new ElementRegEx(elementFilter1
				.bestimmeNaechsteFreieIdRegEx(), "1.ster Ausdruck", ".*"));
		elementFilter1.addRegEx(new ElementRegEx(elementFilter1
				.bestimmeNaechsteFreieIdRegEx(), "2.ter Ausdruck", "B"));
		xmlFilter.addElementFilter(elementFilter1);

		System.out.println(xmlFilter.ausgabeXmlFormatiert());

		System.out.println("Nchste Freie ID: "
				+ xmlFilter.bestimmeNaechsteFreieIdElementFilter());

		ElementFilter elementFilter1b = new ElementFilter(id2,
				"Zweiter Filter Version B");
		elementFilter1b.addRegEx(new ElementRegEx(0, "1.ster Ausdruck", ".*"));
		elementFilter1b.addRegEx(new ElementRegEx(1, "2.ter Ausdruck Test", "Bb"));
		xmlFilter.addElementFilter(elementFilter1b);

		System.out.println(xmlFilter.ausgabeXmlFormatiert());

		/*
		 * Testeinlesen mit einem neuen Filter
		 */
		XmlFilterVerwaltung xml = new XmlFilterVerwaltung();
		xml.einlesenXmlAusString(xmlFilter.ausgabeXmlFormatiert());
		System.out.println("====>\n" + xml.ausgabeXmlFormatiert());

		ElementRegEx test = new ElementRegEx(1, "2.ter Ausdruck Test", "Bb");
		System.out.println("TE:  " + test.toString());
		System.out.println("TE2: " + test.clone().toString());
		
		
		
		/*
		 * Kodierungstest
		 */
		String base64 = xml.stringToBase64(xml.ausgabeXmlFormatiert());
		System.out.println("\nBase64:\n" + base64 + "\n");
		XmlFilterVerwaltung xmlDecodeTest = new XmlFilterVerwaltung();
		String dekodiert = xmlDecodeTest.base64ToString(base64);
		xmlDecodeTest.einlesenXmlAusString(dekodiert);
		System.out.println("XML Dekodiert aus Base64:\n" + xmlDecodeTest.ausgabeXmlFormatiert());
		ElementFilter efTest = new ElementFilter(xmlDecodeTest.bestimmeNaechsteFreieIdElementFilter(), ".*TEST*.");
		xmlDecodeTest.addElementFilter(efTest);
		System.out.println("==>\n" + xmlDecodeTest.ausgabeXmlFormatiert());
		
		
		
		/*
		 * Neu
		 */
		
		XmlFilterVerwaltung xfv = new XmlFilterVerwaltung();
		ElementFilter ef1 = new ElementFilter(xfv.bestimmeNaechsteFreieIdElementFilter(), "wert1");
		xfv.addElementFilter(ef1);
		ElementFilter ef2 = new ElementFilter(xfv.bestimmeNaechsteFreieIdElementFilter(), "wert2");
		xfv.addElementFilter(ef2);
		System.out.println(xfv.ausgabeXmlFormatiert());
		
		XmlFilterVerwaltung xfvNeu = new XmlFilterVerwaltung();
		xfvNeu.einlesenXmlAusString(xfv.ausgabeXmlFormatiert());
		
		

	}

}

