package de.bsvrz.buv.rw.rw.ui.actions;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.NotEnabledException;
import org.eclipse.core.commands.NotHandledException;
import org.eclipse.core.commands.common.NotDefinedException;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchCommandConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.handlers.IHandlerService;

/**
 * Aktion zum ffnen von Perspektiven. Liefert einen Dialog mit der bersicht
 * aller verfgbaren Perspektiven.
 * 
 * @author HofmannJ
 * 
 */
public class ActionPerspektiveOeffnen implements IWorkbenchWindowActionDelegate
{

	@Override
	public void dispose()
	{
	}

	@Override
	public void init(IWorkbenchWindow window)
	{
	}

	@Override
	public void run(IAction action)
	{
		IWorkbench workbench = PlatformUI.getWorkbench();
		if (workbench != null)
		{
			IWorkbenchWindow activeWorkbenchWindow = workbench
					.getActiveWorkbenchWindow();
			if (activeWorkbenchWindow != null)
			{
				IHandlerService handlerService = (IHandlerService) activeWorkbenchWindow
						.getService(IHandlerService.class);

				try
				{
					handlerService.executeCommand(
							IWorkbenchCommandConstants.PERSPECTIVES_SHOW_PERSPECTIVE, null);
				} catch (ExecutionException e)
				{
					e.printStackTrace();
				} catch (NotDefinedException e)
				{
					e.printStackTrace();
				} catch (NotEnabledException e)
				{
					e.printStackTrace();
				} catch (NotHandledException e)
				{
					e.printStackTrace();
				}
			}
		}

	}

	@Override
	public void selectionChanged(IAction action, ISelection selection)
	{
	}

}
