/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.kommandozeilenparameter;

import static org.junit.Assert.assertEquals;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * Fr diesen Test ist es notwendig, den Parameter "
 * <code>-testparameter=123</code>" zu bergeben. Ist dies nicht der Fall, muss
 * der Test scheitern. <br>
 * <b>Wichtig:</b> Dieser Test kann nur als PDE JUnit-Test erfolgen!
 * 
 * @author HofmannJ
 * 
 */
public class KommandozeilenparameterTest
{
	private Kommandozeilenparameter _kmd = null;

	@Before
	public void setUp() throws Exception
	{
		_kmd = Kommandozeilenparameter.getInstanz();
	}

	@After
	public void tearDown() throws Exception
	{
	}

	/**
	 * Hier wird geprft, ob der Wert des Parameters richtig bernommen wurde.
	 */
	@Test
	public void testGetKommandoZeilenParameterWert()
	{
		KmdParameter kommandoZeilenParameter = _kmd
				.getKommandoZeilenParameter("-tesparameter");

		if (kommandoZeilenParameter == null)
		{
			System.out
					.println("Info: Es wurde in der Runconfiguration nicht der Parameter \"-tesparameter=123\" gesetzt. Setze ihn automatisch.");
			KmdParameter kmdParameter = new KmdParameter("-tesparameter", "123");
			Kommandozeilenparameter.getInstanz().setKommandoZeilenParameter(
					kmdParameter);
			kommandoZeilenParameter = _kmd
					.getKommandoZeilenParameter("-tesparameter");
		}

		String wert = kommandoZeilenParameter.getWert();
		assertEquals("123", wert);
	}

	/**
	 * Hier wird geprft, ob der Schlssel des Parameters richtig bernommen
	 * wurde.
	 */
	@Test
	public void testGetKommandoZeilenParameterSchluessel()
	{
		KmdParameter kommandoZeilenParameter = _kmd
				.getKommandoZeilenParameter("-tesparameter");
		String schluessel = kommandoZeilenParameter.getSchluessel();
		assertEquals("-tesparameter", schluessel);
	}

}
